/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_CONFCARD                                            			      */
/* Tabela : CONFCARD                                                   				      */
/*                                                                        				      */
/* Criao:                                                             				      */
/* 06/12/2004 - Rafael dos Santos Lopes                                    			      */
/*                                                                           				      */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_CONFCARD
BEFORE INSERT OR UPDATE OR DELETE
ON CONFCARD FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCFCA := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDTIPOPRAT,0) <> NVL(:NEW.CDTIPOPRAT,0)) OR
           (NVL(:OLD.IDIMPCNFCARD,0) <> NVL(:NEW.IDIMPCNFCARD,0)) OR
           (NVL(:OLD.NRORDCNFCARD,0) <> NVL(:NEW.NRORDCNFCARD,0)) OR
           (NVL(:OLD.IDOPCCNFCARD,0) <> NVL(:NEW.IDOPCCNFCARD,0)) THEN
         :NEW.DTULTATUCFCA := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CONFCARD', :OLD.CDFILIAL, 'CDSERVFILI='||:OLD.CDSERVFILI||'; NRSEQCNFCARD='||:OLD.NRSEQCNFCARD||';CDFILIAL='||:OLD.CDFILIAL||';' , SYSDATE);
   END IF;
END;
/

ALTER TABLE CONFCARD MODIFY DTULTATUCFCA DEFAULT SYSDATE
/

