DROP TYPE RELATORIO_AF_EMAIL_TABLE   
/

DROP TYPE RELATORIO_AF_EMAIL_TYPE
/

CREATE TYPE RELATORIO_AF_EMAIL_TYPE AS OBJECT (
    CDFILDEST           VARCHAR2(4),    --01
    NRSEQAPURAF         VARCHAR2(10),   --02
    NMFILIAL            VARCHAR2(30),   --03
    CDFILLANC           VARCHAR2(4),    --04
    NRAUTOFORN          VARCHAR2(10),   --05
    CDOPERADOR          VARCHAR2(12),   --06
    CDFORNECED          VARCHAR2(21),   --07
    VRTOTALAF           FLOAT(126),     --08
    DTAUTOFORN          DATE,           --09
    IDTIPOEMITAF        VARCHAR2(1),    --10
    NMEMPRESA           VARCHAR2(150),  --11
    SGESTADOEMPR        VARCHAR2(2),    --12
    NRCEPEMPR           VARCHAR2(15),   --13
    DSENDEEMPR          VARCHAR2(250),  --14
    NMMUNIEMPR          VARCHAR2(30),   --15
    IDTPIJUREMPR        VARCHAR2(1),    --16
    NRINSJUREMPR        VARCHAR2(20),   --17
    NMBAIREMPR          VARCHAR2(50),   --18
    NMFILIDEST          VARCHAR2(30),   --19
    NRINSJURFILI        VARCHAR2(20),   --20
    IDTPIJURFILI        VARCHAR2(1),    --21
    NMRAZSOCFILI        VARCHAR2(100),  --22
    DSPERIENTFIL        VARCHAR2(50),   --23
    OBSERVACAO          VARCHAR2(1),    --24
    CDINSCESTA          VARCHAR2(20),   --25
    NRINSCESTAEMPR      VARCHAR2(20),   --26
    CDFORMPGTO          VARCHAR2(2),    --27
    IDTPFORPGTAF        VARCHAR2(1),    --28
    NRDIAPGFIXAF        NUMBER(2),      --29
    NRPARCPGTOAF        NUMBER(2),      --30
    IDSITUATUAAF        VARCHAR2(1),    --31
    IDIMAUTOFORN        VARCHAR2(1),    --32
    IDTIPOFRETAF        VARCHAR2(1),    --33
    IDAUTOFORNEX        VARCHAR2(1),    --34
    IDTIPOLANCAF        VARCHAR2(1),    --35
    IDAFFORALIM         VARCHAR2(1),    --36
    IDBAIXAAF           VARCHAR2(1),    --37
    IDTPIJURFORN        VARCHAR2(1),    --38
    NRINSJURFORN        VARCHAR2(20),   --39
    NMRAZSOCFORN        VARCHAR2(100),  --40
    NMFANTFORN          VARCHAR2(450),  --41
    DSENDEFORN          VARCHAR2(60),   --42
    NMCONTFORN          VARCHAR2(30),   --43
    NRTELEFORN1         VARCHAR2(25),   --44
    NRTELEFORN          VARCHAR2(25),   --45
    DSEMAILCOT          VARCHAR2(100),  --46
    IDTPIJURCLIE        VARCHAR2(1),    --47
    NRINSJURCLIE        VARCHAR2(20),   --48
    NMRAZSOCCLIE        VARCHAR2(100),  --49
    DSENDECLIE          VARCHAR2(60),   --50
    NMBAIRCLIE          VARCHAR2(50),   --51
    SGESTADOCLIE        VARCHAR2(2),    --52
    NRCEPCLIE           VARCHAR2(15),   --53
    NRINSESTCLIE        VARCHAR2(20),   --54
    NMMUNICLIE          VARCHAR2(30),   --55
    CDCLIENTE           VARCHAR2(21),   --56
    NMOPERADOR          VARCHAR2(40),   --57
    NMMUNICIFIL         VARCHAR2(30),   --58
    DSENDEFILI          VARCHAR2(60),   --59
    NMBAIRFILI          VARCHAR2(50),   --60
    SGESTADOFIL         VARCHAR2(2),    --61
    NRCEPFILI           VARCHAR2(15),   --62
    NRTELEFILI          VARCHAR2(25),   --63
    DSEMAILFILI         VARCHAR2(40),   --64
    DTPROGENTAF         DATE,           --65
    CDPRODUTO           VARCHAR2(10),   --66
    QTPROGENTAF         FLOAT(126),     --67
    VRPREUNIAF          FLOAT(126),     --68
    VALTOTAL            FLOAT(126),     --69
    CDARVPROD           VARCHAR2(20),   --70
    NMPRODUTO           VARCHAR2(100),  --71
    CDMARCA             VARCHAR2(5),    --72
    NMMARCA             VARCHAR2(20),   --73
    NMMARCA_SEG         VARCHAR2(20),   --74
    NMSEGMARCA          VARCHAR2(50),   --75
    TXOBSITMAF          VARCHAR2(2000), --76
    DSPRAZOPGTAF        VARCHAR2(1100), --77
    NMFORMPGTO          VARCHAR2(30),   --78
    DSOBSFILIAL         VARCHAR2(2000), --79
    DSOBSUNIDADE        CLOB,           --80
    IDEXIBEOBSFIL       VARCHAR2(1),    --81
    NMREPRINSEST        VARCHAR2(150),  --82
    NRINSJURIEST        VARCHAR2(20),   --83
    IDTPIJURIEST        VARCHAR2(1),    --84
    DSENDEIEST          VARCHAR2(250),  --85
    NMBAIRIEST          VARCHAR2(50),   --86
    SGESTADOEST         VARCHAR2(2),    --87
    NRCEPIEST           VARCHAR2(15),   --88
    NMMUNICIPIOEST      VARCHAR2(30),   --89
    IDENDFATURAMENTOAF  VARCHAR2(2),    --90
    IDREPRESENTAFATAF   VARCHAR2(2),    --91
    IDENDCOBRANCAAF     VARCHAR2(2),    --92
    IDREPRESENTACOBRAAF VARCHAR2(2),    --93
    CDPRODUTOXML        VARCHAR2(2000), --94
    DSPRODUTO           VARCHAR2(4000), --95
    DSCOMPENDFIL        VARCHAR2(200),  --96
    IDUTDIAPGTAF        VARCHAR2(1),    --97
    DSMENSAUTF          VARCHAR2(2000), --98
    IDAPENDICE          VARCHAR2(1),    --99
    IDTIPOLANITM        VARCHAR2(1),    --100
    TIPO                VARCHAR2(1),    --101
    DTUTILIZACAO        DATE);          --102
/

CREATE TYPE RELATORIO_AF_EMAIL_TABLE AS TABLE OF RELATORIO_AF_EMAIL_TYPE
/

CREATE OR REPLACE FUNCTION RELATORIO_AF_EMAIL (P_NRSEQAPURAF      IN VARCHAR2,
                                               P_CDFILLANC        IN VARCHAR2,
                                               P_IMPRIMEOBSPROD   IN VARCHAR2,
                                               P_IDEXIBEOBSFIL    IN VARCHAR2,
                                               P_CDFORNECED       IN VARCHAR2,
                                               P_CDARVPRODINI     IN VARCHAR2,
                                               P_CDARVPRODFIN     IN VARCHAR2,
                                               P_CDFILDEST        IN VARCHAR2, --Lista
                                               P_NRAUTOFORN       IN VARCHAR2, --Lista
                                               P_NRSEQENVIOAFORN  IN VARCHAR2, --Lista
                                               P_CDOPERADOR       IN VARCHAR2, --Lista
                                               P_DTENTREGAINI     IN DATE,
                                               P_DTENTREGAFIN     IN DATE,
                                               P_DTAUTOFORNINI    IN DATE,
                                               P_DTAUTOFORNFIN    IN DATE,
                                               P_EXIBEAPENDICEUNIDADE IN VARCHAR2 DEFAULT NULL,
                                               P_TIPO             IN VARCHAR2 DEFAULT NULL,
                                               P_CDREGIAO         IN VARCHAR2 DEFAULT NULL,
                                               P_IDAFIMP          IN VARCHAR2 DEFAULT NULL,
                                               P_IDDTUTILIZACAO   IN VARCHAR2 DEFAULT NULL,
                                               P_CDOPERALANC      IN VARCHAR2 DEFAULT NULL)
RETURN RELATORIO_AF_EMAIL_TABLE PIPELINED AS L_RELATORIO_AF_EMAIL_TYPE RELATORIO_AF_EMAIL_TYPE;

    V_IDSISDOS        PARAMGERAL.IDSISDOS%TYPE;
    V_IDRESTRFILIOPER PARAMGERAL.IDRESTRFILIOPER%TYPE;
    V_CDPRODUTOXML    VARCHAR2(2000);
    V_DSPRODUTO       PRODFORNCOMP.DSPRODUTO%TYPE;
    V_DSMENSAUTF      VARCHAR2(2000);
    V_DTUTILIZACAO    DATE;

    V_DSPERIENTFIL    PARCMPSUP.DSPERIENTFIL%TYPE;

    V_NMOPERADOR      OPERADOR.NMOPERADOR%TYPE;

    V_CDFORNECED      FORNECEDOR.CDFORNECED%TYPE;
    V_IDTPIJURFORN    FORNECEDOR.IDTPIJURFORN%TYPE;
    V_NRINSJURFORN    FORNECEDOR.NRINSJURFORN%TYPE;
    V_NMRAZSOCFORN    FORNECEDOR.NMRAZSOCFORN%TYPE;
    V_NMFANTFORN      FORNECEDOR.NMFANTFORN%TYPE;
    V_DSEMAILCOT      FORNECEDOR.DSEMAILCOT%TYPE;

    V_DSENDEFORN     ENDEFORN.DSENDEFORN%TYPE;
    V_NMCONTFORN     ENDEFORN.NMCONTFORN%TYPE;
    V_NRTELEFORN1    ENDEFORN.NRTELEFORN1%TYPE;
    V_NRTELEFORN     ENDEFORN.NRTELEFORN%TYPE;

    V_CLIENFILIAL    CLIENTE.CDCLIENTE%TYPE;

    V_CDCLIENTE      CLIENTE.CDCLIENTE%TYPE;
    V_IDTPIJURCLIE   CLIENTE.IDTPIJURCLIE%TYPE;
    V_NMRAZSOCCLIE   CLIENTE.NMRAZSOCCLIE%TYPE;
    V_NRINSJURCLIE   CLIENTE.NRINSJURCLIE%TYPE;
    V_NRINSESTCLIE   CLIENTE.NRINSESTCLIE%TYPE;

    V_DSENDECLIE     ENDECLIE.DSENDECLIE%TYPE;
    V_NMBAIRCLIE     ENDECLIE.NMBAIRCLIE%TYPE;
    V_NRCEPCLIE      ENDECLIE.NRCEPCLIE%TYPE;
    V_NMMUNICLIE     MUNICIPIO.NMMUNICIPIO%TYPE;
    V_SGESTADOCLIE   MUNICIPIO.SGESTADO%TYPE;    

    V_IDTPIJUREMPR   EMPRESA.IDTPIJUREMPR%TYPE;
    V_NRINSJUREMPR   EMPRESA.NRINSJUREMPR%TYPE;
    V_NMEMPRESA      VARCHAR2(150);
    V_DSENDEEMPR     VARCHAR2(250);
    V_NMBAIREMPR     EMPRESA.NMBAIREMPR%TYPE;
    V_SGESTADOEMPR   EMPRESA.SGESTADO%TYPE;
    V_NRCEPEMPR      EMPRESA.NRCEPEMPR%TYPE;
    V_NMMUNIEMPR     MUNICIPIO.NMMUNICIPIO%TYPE;
    V_NRINSCESTAEMPR VARCHAR2(20);

    V_NMREPRINSEST   VARCHAR2(150);
    V_DSENDEIEST     VARCHAR2(250);          
    V_IDTPIJURIEST   INSCRESTAD.IDTPIJURIEST%TYPE;
    V_NRINSJURIEST   VARCHAR2(50);
    V_NMBAIRIEST     INSCRESTAD.NMBAIRIEST%TYPE;
    V_NRCEPIEST      VARCHAR2(50);
    V_NMMUNICIPIOEST MUNICIPIO.NMMUNICIPIO%TYPE;
    V_SGESTADOEST    ESTADO.SGESTADO%TYPE;

    V_CDINSCESTA     VARCHAR2(50);
    V_CDSEGMARCA     VARCHAR2(50);
    V_NMSEGMARCA     VARCHAR2(500);

    V_NMMUNICIFIL   MUNICIPIO.NMMUNICIPIO%TYPE;
    V_DSENDEFILI    ENDEFILI.DSENDEFILI%TYPE;
    V_NMBAIRFILI    ENDEFILI.NMBAIRFILI%TYPE;
    V_SGESTADOFIL   ENDEFILI.SGESTADO%TYPE;
    V_NRCEPFILI     VARCHAR2(50);
    V_NRTELEFILI    ENDEFILI.NRTELEFILI%TYPE;
    V_DSEMAILFILI   ENDEFILI.DSEMAILFILI%TYPE;
    V_DSCOMPENDFIL  ENDEFILI.DSCOMPENDFIL%TYPE;

    V_NMMUNICIFILEE MUNICIPIO.NMMUNICIPIO%TYPE;
    V_DSENDEFILIEE  ENDEFILI.DSENDEFILI%TYPE;    
    V_NMBAIRFILIEE  ENDEFILI.NMBAIRFILI%TYPE;
    V_SGESTADOFILEE ENDEFILI.SGESTADO%TYPE;
    V_NRCEPFILIEE   VARCHAR2(50);
    V_NRTELEFILIEE  ENDEFILI.NRTELEFILI%TYPE;
    V_DSEMAILFILIEE ENDEFILI.DSEMAILFILI%TYPE;
    V_DSCOMPENDFILEE ENDEFILI.DSCOMPENDFIL%TYPE;

    V_NMMUNICIFILCC MUNICIPIO.NMMUNICIPIO%TYPE;
    V_DSENDEFILICC  ENDEFILI.DSENDEFILI%TYPE;    
    V_NMBAIRFILICC  ENDEFILI.NMBAIRFILI%TYPE;
    V_SGESTADOFILCC ENDEFILI.SGESTADO%TYPE;
    V_NRCEPFILICC   VARCHAR2(50);
    V_NRTELEFILICC  ENDEFILI.NRTELEFILI%TYPE;
    V_DSEMAILFILICC ENDEFILI.DSEMAILFILI%TYPE;
    V_DSCOMPENDFILCC ENDEFILI.DSCOMPENDFIL%TYPE;

    V_CDFORMPGTO     FORMPGTO.CDFORMPGTO%TYPE;
    V_NMFORMPGTO     FORMPGTO.NMFORMPGTO%TYPE;

    V_CHAVE          VARCHAR2(10) := '_';
    V_TIPO           VARCHAR2(1) := NULL;
    V_TIPO_1         VARCHAR2(1) := NULL;

    V_PRAZOPGTAF    VARCHAR2(1100);
    V_DSOBSFILIAL   VARCHAR2(2000);
    V_DSOBSUNIDADE  CLOB;

    V_IDENDFATURAMENTOAF       ENDERAUTOFORNE.IDENDFATURAMENTOAF%TYPE;
    V_IDREPRESENTAFATAF        ENDERAUTOFORNE.IDREPRESENTAFATAF%TYPE;
    V_IDENDCOBRANCAAF          ENDERAUTOFORNE.IDENDCOBRANCAAF%TYPE;
    V_IDREPRESENTACOBRAAF      ENDERAUTOFORNE.IDREPRESENTACOBRAAF%TYPE;
    V_DTENTREGAINI  DATE;
    V_DTENTREGAFIN  DATE;

    PROCEDURE INICIA_VARIAVEIS AS
    BEGIN
        V_CDPRODUTOXML := NULL;
        V_DSPRODUTO    := NULL;
        V_DSMENSAUTF   := NULL;
        V_DTUTILIZACAO := NULL;

        V_NMOPERADOR   := NULL;

        V_CDFORNECED   := NULL;
        V_IDTPIJURFORN := NULL;
        V_NRINSJURFORN := NULL;
        V_NMRAZSOCFORN := NULL;
        V_NMFANTFORN   := NULL;
        V_DSEMAILCOT   := NULL;

        V_DSENDEFORN   := NULL;
        V_NMCONTFORN   := NULL;
        V_NRTELEFORN1  := NULL;
        V_NRTELEFORN   := NULL;

        V_CLIENFILIAL  := NULL;

        V_CDCLIENTE    := NULL;
        V_IDTPIJURCLIE := NULL;
        V_NMRAZSOCCLIE := NULL;
        V_NRINSJURCLIE := NULL;
        V_NRINSESTCLIE := NULL;

        V_DSENDECLIE   := NULL;
        V_NMBAIRCLIE   := NULL;
        V_NRCEPCLIE    := NULL;
        V_NMMUNICLIE   := NULL;
        V_SGESTADOCLIE := NULL;

        V_DSPERIENTFIL := NULL;

        V_IDTPIJUREMPR   := NULL;
        V_NRINSJUREMPR   := NULL;
        V_NMEMPRESA      := NULL;
        V_DSENDEEMPR     := NULL;
        V_NMBAIREMPR     := NULL;
        V_SGESTADOEMPR   := NULL;
        V_NRCEPEMPR      := NULL;
        V_NMMUNIEMPR     := NULL;
        V_NRINSCESTAEMPR := NULL;

        V_NMREPRINSEST   := NULL;
        V_DSENDEIEST     := NULL;
        V_IDTPIJURIEST   := NULL;
        V_NRINSJURIEST   := NULL;
        V_NMBAIRIEST     := NULL;
        V_NRCEPIEST      := NULL;
        V_NMMUNICIPIOEST := NULL;

        V_CDINSCESTA     := NULL;

        V_CDSEGMARCA     := NULL;
        V_NMSEGMARCA     := NULL;

        V_NMMUNICIFIL    := NULL;
        V_DSENDEFILI     := NULL;
        V_NMBAIRFILI     := NULL;
        V_SGESTADOFIL    := NULL;
        V_NRCEPFILI      := NULL;
        V_NRTELEFILI     := NULL;
        V_DSEMAILFILI    := NULL;
        V_DSCOMPENDFIL   := NULL;

        V_NMMUNICIFILEE  := NULL;
        V_DSENDEFILIEE   := NULL;
        V_NMBAIRFILIEE   := NULL;
        V_SGESTADOFILEE  := NULL;
        V_NRCEPFILIEE    := NULL;
        V_NRTELEFILIEE   := NULL;
        V_DSEMAILFILIEE  := NULL;
        V_DSCOMPENDFILEE := NULL;

        V_NMMUNICIFILCC  := NULL;
        V_DSENDEFILICC   := NULL;
        V_NMBAIRFILICC   := NULL;
        V_SGESTADOFILCC  := NULL;
        V_NRCEPFILICC    := NULL;
        V_NRTELEFILICC   := NULL;
        V_DSEMAILFILICC  := NULL;
        V_DSCOMPENDFILCC := NULL;

        V_CDFORMPGTO     := NULL;
        V_NMFORMPGTO     := NULL;
    END;
BEGIN
    IF (NVL(P_DTENTREGAINI||P_DTENTREGAFIN, '01/01/1000') = '01/01/1000') THEN
        V_DTENTREGAINI  := SYSDATE-365;
        V_DTENTREGAFIN  := SYSDATE+365;
    ELSE
       V_DTENTREGAINI  := P_DTENTREGAINI;
       V_DTENTREGAFIN  := P_DTENTREGAFIN;
    END IF;
    SELECT NVL(MAX(IDSISDOS), '1'), NVL(MAX(IDRESTRFILIOPER), 'N')
      INTO V_IDSISDOS, V_IDRESTRFILIOPER
      FROM PARAMGERAL;
    V_TIPO := NVL(P_TIPO, '0');
    IF V_TIPO = '3' THEN
       V_TIPO := '1';
    END IF;
    FOR C_FILIAL IN (SELECT CDFILIAL, NRINSJURFILI, IDTPIJURFILI, NMRAZSOCFILI,
                            CDEMPRESA, CDINSCESTA, CDREGIAO, NMFILIAL NMFILIDEST
                       FROM FILIAL
                      WHERE INSTR(NVL(P_CDFILDEST, '_'||FILIAL.CDFILIAL||'_'), FILIAL.CDFILIAL) > 0
                        AND FILIAL.CDREGIAO IS NOT NULL
                        AND NVL(FILIAL.IDCNTRRESC, 'N') <> 'S'
                        AND INSTR('_'||NVL(P_CDREGIAO, FILIAL.CDREGIAO)||'_', FILIAL.CDREGIAO) > 0
                        AND ((V_IDRESTRFILIOPER = 'N') OR (NVL(P_CDOPERALANC, 'W') = 'W') OR EXISTS (SELECT 1
                                                                                                       FROM FILIOPER
                                                                                                      WHERE FILIOPER.CDFILIAL   = FILIAL.CDFILIAL
                                                                                                        AND FILIOPER.CDOPERADOR = P_CDOPERALANC))) LOOP
        FOR C_AUTOFORNE IN (SELECT AUTOFORNE.NRSEQAPURAF,
                                   AUTOFORNE.CDFILDEST,
                                   AUTOFORNE.CDFILLANC,
                                   AUTOFORNE.NRAUTOFORN,
                                   AUTOFORNE.CDOPERADOR,
                                   AUTOFORNE.CDFORNECED,
                                   AUTOFORNE.VRTOTALAF,
                                   AUTOFORNE.DTAUTOFORN,
                                   AUTOFORNE.IDTIPOEMITAF,
                                   AUTOFORNE.CDFORMPGTO,
                                   AUTOFORNE.IDTPFORPGTAF,
                                   AUTOFORNE.NRDIAPGFIXAF,
                                   AUTOFORNE.NRPARCPGTOAF,
                                   AUTOFORNE.IDSITUATUAAF,
                                   AUTOFORNE.IDIMAUTOFORN,
                                   AUTOFORNE.IDTIPOFRETAF,
                                   AUTOFORNE.IDAUTOFORNEX,
                                   AUTOFORNE.IDTIPOLANCAF,
                                   AUTOFORNE.IDAFFORALIM,
                                   AUTOFORNE.IDBAIXAAF,
                                   AUTOFORNE.IDUTDIAPGTAF,
                                   AUTOFORNE.NRSEQENVIOAFORN
                              FROM AUTOFORNE
                             WHERE NVL(AUTOFORNE.NRSEQAPURAF, 'N') = NVL(P_NRSEQAPURAF, NVL(AUTOFORNE.NRSEQAPURAF, 'N'))
                               AND INSTR(NVL(P_CDFILLANC, '_'||AUTOFORNE.CDFILLANC||'_'), AUTOFORNE.CDFILLANC) > 0
                               AND AUTOFORNE.CDFILDEST = C_FILIAL.CDFILIAL
                               AND ((INSTR(NVL(P_NRAUTOFORN, AUTOFORNE.NRAUTOFORN), AUTOFORNE.NRAUTOFORN) > 0) OR (P_NRAUTOFORN = 'T'))
                             AND ((INSTR(NVL(P_CDFORNECED, AUTOFORNE.CDFORNECED), AUTOFORNE.CDFORNECED) > 0) OR (P_CDFORNECED = 'T'))
                               AND ((INSTR(NVL(P_NRSEQENVIOAFORN, NVL(AUTOFORNE.NRSEQENVIOAFORN, 'X')), NVL(AUTOFORNE.NRSEQENVIOAFORN, 'X')) > 0) OR (P_NRSEQENVIOAFORN = 'T'))
                               AND (TO_CHAR(AUTOFORNE.DTAUTOFORN, 'DD/MM/YYYY') BETWEEN NVL(P_DTAUTOFORNINI, TO_CHAR(AUTOFORNE.DTAUTOFORN, 'DD/MM/YYYY')) AND NVL(P_DTAUTOFORNFIN, TO_CHAR(AUTOFORNE.DTAUTOFORN, 'DD/MM/YYYY')))
                               AND AUTOFORNE.IDAFFORALIM = 'N'
                               AND AUTOFORNE.IDSITUATUAAF IS NULL
                               AND NVL(AUTOFORNE.IDBAIXAAF, '1') IN ('1', '2', '3')
                             --  AND ((NVL(AUTOFORNE.IDAFPRODWEB, 'N') = 'N') OR (AUTOFORNE.IDBAIXAAF IN ('2', '3')))
                               AND NVL(AUTOFORNE.IDBAIXAAF,'0') <> '4'
                               AND NVL(AUTOFORNE.IDBAIXAAF,'0') <> '6'
                               AND NVL(AUTOFORNE.IDBAIXAAF,'0') <> '5'
                               AND (
                               (EXISTS(SELECT 1
                                           FROM ITEMAUTF
                                          WHERE AUTOFORNE.CDFILDEST = ITEMAUTF.CDFILDEST
                                            AND AUTOFORNE.CDFILLANC = ITEMAUTF.CDFILLANC
                                            AND AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN
                                            AND DTPROGENTAF BETWEEN V_DTENTREGAINI AND V_DTENTREGAFIN)))
                               AND ((P_IDAFIMP = 'N' AND AUTOFORNE.IDIMAUTOFORN = 'N') OR (NVL(P_IDAFIMP, 'T') = 'T'))
                             ) LOOP

            FOR C_ITEM IN (SELECT ITEMAUTF.CDFILDEST,
                                  ITEMAUTF.CDFILLANC,
                                  ITEMAUTF.NRAUTOFORN,
                                  ITEMAUTF.DTPROGENTAF,
                                  ITEMAUTF.QTPROGENTAF,
                                  ITEMAUTF.VRPREUNIAF,
                                  ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF VALTOTAL,
                                  ITEMAUTF.TXOBSITMAF,
                                  ITEMAUTF.IDTIPOLANITM,
                                  ITEMAUTF.CDSEGMARCA,
                                  NVL(ITEMAUTF.IDITAFMIGRADA, 'N') IDITAFMIGRADA,
                                  NVL(ITEMAUTF.DTENTRITMSOL, ITEMAUTF.DTPROGENTAF) DTENTRITMSOL,
                                  PRODUTO.CDPRODUTO,
                                  PRODUTO.CDPRODESTO,
                                  PRODUTO.CDARVPROD,
                                  PRODUTO.NMPRODUTO||' - '||PRODUTO.SGUNIDADE NMPRODUTO,
                                  MARCA.CDMARCA,
                                  MARCA.NMMARCA
                             FROM ITEMAUTF INNER JOIN PRODUTO ON ITEMAUTF.CDPRODUTO = PRODUTO.CDPRODUTO
                                           INNER JOIN MARCA ON ITEMAUTF.CDMARCA = MARCA.CDMARCA                                            
                            WHERE (( (DTPROGENTAF BETWEEN V_DTENTREGAINI AND V_DTENTREGAFIN)))
                              AND PRODUTO.CDARVPROD BETWEEN NVL(P_CDARVPRODINI, PRODUTO.CDARVPROD) AND NVL(P_CDARVPRODFIN, PRODUTO.CDARVPROD)
                              AND ITEMAUTF.CDFILLANC = C_AUTOFORNE.CDFILLANC
                              AND ITEMAUTF.CDFILDEST = C_AUTOFORNE.CDFILDEST
                              AND ITEMAUTF.NRAUTOFORN = C_AUTOFORNE.NRAUTOFORN)

            LOOP

                IF V_CHAVE <> C_AUTOFORNE.NRAUTOFORN THEN
                    IF NVL(P_TIPO, '0') = '3' THEN
                        SELECT NVL(MAX(ENVIOAFFORN.IDTCLASSENVAFOR), 'N')
                          INTO V_TIPO_1
                          FROM ENVIOAFFORN
                         WHERE ENVIOAFFORN.NRSEQENVIOAFORN = C_AUTOFORNE.NRSEQENVIOAFORN;
                    END IF;
                    V_CHAVE := C_AUTOFORNE.NRAUTOFORN;
                END IF;

                IF V_TIPO_1 = 'P' THEN
                    V_TIPO := '1';
                ELSE
                    IF V_TIPO <> '1' THEN
                        V_TIPO := '0';
                    END IF;   
                END IF;

                IF ((NVL(C_ITEM.IDITAFMIGRADA, 'N')  = 'N') AND ((NVL(V_TIPO, '0')||C_ITEM.NMPRODUTO <> '0PEDIDO_CANCELADO') OR (NVL(V_TIPO, '0') = '1'))) THEN
                    INICIA_VARIAVEIS;

                    BEGIN
                        SELECT NMOPERADOR
                          INTO V_NMOPERADOR
                          FROM OPERADOR
                         WHERE CDOPERADOR = C_AUTOFORNE.CDOPERADOR;
                    EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                            V_NMOPERADOR := NULL;
                    END;

                    BEGIN
                        SELECT CDFORNECED, IDTPIJURFORN, NRINSJURFORN, NMRAZSOCFORN, NMFANTFORN, DSEMAILCOT
                          INTO V_CDFORNECED, V_IDTPIJURFORN, V_NRINSJURFORN, V_NMRAZSOCFORN, V_NMFANTFORN, V_DSEMAILCOT
                          FROM FORNECEDOR
                         WHERE CDFORNECED = C_AUTOFORNE.CDFORNECED;
                    EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                            V_CDFORNECED   := NULL;
                            V_IDTPIJURFORN := NULL;
                            V_NRINSJURFORN := NULL;
                            V_NMRAZSOCFORN := NULL;
                            V_NMFANTFORN   := NULL;
                            V_DSEMAILCOT   := NULL;
                    END;


                    BEGIN
                        SELECT DSENDEFORN, NMCONTFORN, NRTELEFORN1, NRTELEFORN
                        INTO V_DSENDEFORN, V_NMCONTFORN, V_NRTELEFORN1, V_NRTELEFORN
                        FROM ENDEFORN
                        WHERE CDFORNECED = V_CDFORNECED
                        AND IDTPENDEFORN = 'P';
                    EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                            V_DSENDEFORN  := NULL;
                            V_NMCONTFORN  := NULL;
                            V_NRTELEFORN1 := NULL;
                            V_NRTELEFORN  := NULL;                            
                    END;

                    BEGIN
                        SELECT CDCLIENTE
                        INTO V_CLIENFILIAL
                        FROM CLIENFILIAL
                        WHERE IDCLIENPRIN = 'S'
                        AND CDFILIAL = C_AUTOFORNE.CDFILDEST;

                        SELECT CDCLIENTE, IDTPIJURCLIE, NMRAZSOCCLIE, NRINSESTCLIE, NRINSJURCLIE
                        INTO V_CDCLIENTE, V_IDTPIJURCLIE, V_NMRAZSOCCLIE, V_NRINSESTCLIE, V_NRINSJURCLIE
                        FROM CLIENTE
                        WHERE CDCLIENTE = V_CLIENFILIAL;

                        SELECT ENDECLIE.DSENDECLIE, ENDECLIE.NMBAIRCLIE, MUNICIPIO.NMMUNICIPIO, ENDECLIE.NRCEPCLIE, ENDECLIE.SGESTADO
                        INTO V_DSENDECLIE, V_NMBAIRCLIE, V_NMMUNICLIE, V_NRCEPCLIE, V_SGESTADOCLIE
                        FROM ENDECLIE INNER JOIN MUNICIPIO ON ENDECLIE.CDPAIS = MUNICIPIO.CDPAIS
                                                          AND ENDECLIE.SGESTADO = MUNICIPIO.SGESTADO
                                                          AND ENDECLIE.CDMUNICIPIO = MUNICIPIO.CDMUNICIPIO
                        WHERE ENDECLIE.CDCLIENTE = V_CDCLIENTE
                        AND ENDECLIE.IDTPENDECLIE = 'P';
                    EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                            V_CLIENFILIAL  := NULL;

                            V_CDCLIENTE    := NULL;
                            V_IDTPIJURCLIE := NULL;
                            V_NMRAZSOCCLIE := NULL;
                            V_NRINSESTCLIE := NULL;
                            V_NRINSJURCLIE := NULL;

                            V_DSENDECLIE   := NULL;
                            V_NMBAIRCLIE   := NULL;
                            V_NMMUNICLIE   := NULL;
                            V_NRCEPCLIE    := NULL;                            
                    END;

                    BEGIN
                        SELECT DSPERIENTFIL
                        INTO V_DSPERIENTFIL
                        FROM PARCMPSUP
                        WHERE CDFILIAL = C_AUTOFORNE.CDFILDEST;
                    EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                            V_DSPERIENTFIL := NULL;
                    END;                        

                    BEGIN
                        SELECT EMPRESA.IDTPIJUREMPR, EMPRESA.NRINSJUREMPR, EMPRESA.NMEMPRESA, EMPRESA.DSENDEEMPR, EMPRESA.NMBAIREMPR, EMPRESA.SGESTADO, EMPRESA.NRCEPEMPR, MUNICIPIO.NMMUNICIPIO, EMPRESA.NRINSCESTA
                        INTO V_IDTPIJUREMPR, V_NRINSJUREMPR, V_NMEMPRESA, V_DSENDEEMPR, V_NMBAIREMPR, V_SGESTADOEMPR, V_NRCEPEMPR, V_NMMUNIEMPR, V_NRINSCESTAEMPR
                        FROM EMPRESA INNER JOIN MUNICIPIO ON EMPRESA.CDPAIS = MUNICIPIO.CDPAIS
                                                        AND EMPRESA.SGESTADO = MUNICIPIO.SGESTADO
                                                        AND EMPRESA.CDMUNICIPIO = MUNICIPIO.CDMUNICIPIO
                        WHERE EMPRESA.CDEMPRESA = C_FILIAL.CDEMPRESA;
                    EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                            V_IDTPIJUREMPR   := NULL;
                            V_NRINSJUREMPR   := NULL;
                            V_NMEMPRESA      := NULL;
                            V_DSENDEEMPR     := NULL;
                            V_NMBAIREMPR     := NULL;
                            V_SGESTADOEMPR   := NULL;
                            V_NRCEPEMPR      := NULL;
                            V_NMMUNIEMPR     := NULL;
                            V_NRINSCESTAEMPR := NULL;
                    END;


                    BEGIN
                        SELECT NMREPRINSEST, DSENDEIEST, IDTPIJURIEST, NRINSJURIEST, NMBAIRIEST, NRCEPIEST,
                               NMMUNICIPIO
                        INTO V_NMREPRINSEST, V_DSENDEIEST, V_IDTPIJURIEST, V_NRINSJURIEST, V_NMBAIRIEST, V_NRCEPIEST,
                             V_NMMUNICIPIOEST
                        FROM INSCRESTAD INNER JOIN MUNICIPIO ON INSCRESTAD.CDPAIS = MUNICIPIO.CDPAIS
                                                            AND INSCRESTAD.SGESTADO = MUNICIPIO.SGESTADO
                                                            AND INSCRESTAD.CDMUNICIPIO = MUNICIPIO.CDMUNICIPIO
                        WHERE CDINSCESTA = C_FILIAL.CDINSCESTA
                        AND CDEMPRESA = C_FILIAL.CDEMPRESA;
                    EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                            V_NMREPRINSEST   := NULL;
                            V_DSENDEIEST     := NULL;
                            V_IDTPIJURIEST   := NULL;
                            V_NRINSJURIEST   := NULL;
                            V_NMBAIRIEST     := NULL;
                            V_NRCEPIEST      := NULL;
                            V_NMMUNICIPIOEST := NULL;
                    END;

                    BEGIN
                        SELECT C_ITEM.CDMARCA||'/'||MARCA.CDMARCA, C_ITEM.NMMARCA||'/'||MARCA.NMMARCA
                        INTO V_CDSEGMARCA, V_NMSEGMARCA
                        FROM MARCA
                        WHERE CDMARCA = C_ITEM.CDSEGMARCA;
                    EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                            V_CDSEGMARCA := C_ITEM.CDMARCA;
                            V_NMSEGMARCA := C_ITEM.NMMARCA;
                    END;                           

                    BEGIN
                        SELECT NMMUNICIPIO, DSENDEFILI, NMBAIRFILI, ENDEFILI.SGESTADO, NRCEPFILI, NRTELEFILI, DSEMAILFILI, DSCOMPENDFIL
                        INTO V_NMMUNICIFIL, V_DSENDEFILI, V_NMBAIRFILI, V_SGESTADOFIL, V_NRCEPFILI, V_NRTELEFILI, V_DSEMAILFILI, V_DSCOMPENDFIL                        
                        FROM ENDEFILI INNER JOIN MUNICIPIO ON ENDEFILI.CDPAIS = MUNICIPIO.CDPAIS
                                                          AND ENDEFILI.SGESTADO = MUNICIPIO.SGESTADO
                                                          AND ENDEFILI.CDMUNICIPIO = MUNICIPIO.CDMUNICIPIO
                        WHERE ENDEFILI.IDTPENDEFILI = 'P'
                        AND ENDEFILI.CDFILIAL = C_AUTOFORNE.CDFILDEST;
                    EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                            V_NMMUNICIFIL := NULL;
                            V_DSENDEFILI := NULL;
                            V_NMBAIRFILI := NULL;
                            V_SGESTADOFIL := NULL;
                            V_NRCEPFILI := NULL;
                            V_NRTELEFILI := NULL;
                            V_DSEMAILFILI := NULL;
                            V_DSCOMPENDFIL := NULL;                            
                    END; 

                    BEGIN
                        SELECT NMMUNICIPIO, DSENDEFILI, NMBAIRFILI, ENDEFILI.SGESTADO, NRCEPFILI, NRTELEFILI, DSEMAILFILI, DSCOMPENDFIL
                        INTO V_NMMUNICIFILEE, V_DSENDEFILIEE, V_NMBAIRFILIEE, V_SGESTADOFILEE, V_NRCEPFILIEE, V_NRTELEFILIEE, V_DSEMAILFILIEE, V_DSCOMPENDFILEE                        
                        FROM ENDEFILI INNER JOIN MUNICIPIO ON ENDEFILI.CDPAIS = MUNICIPIO.CDPAIS
                                                          AND ENDEFILI.SGESTADO = MUNICIPIO.SGESTADO
                                                          AND ENDEFILI.CDMUNICIPIO = MUNICIPIO.CDMUNICIPIO
                        WHERE ENDEFILI.IDTPENDEFILI = 'T'
                        AND ENDEFILI.CDFILIAL = C_AUTOFORNE.CDFILDEST;
                    EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                            V_NMMUNICIFILEE := NULL;
                            V_DSENDEFILIEE := NULL;
                            V_NMBAIRFILIEE := NULL;
                            V_SGESTADOFILEE := NULL;
                            V_NRCEPFILIEE := NULL;
                            V_NRTELEFILIEE := NULL;
                            V_DSEMAILFILIEE := NULL;
                            V_DSCOMPENDFILEE := NULL;                            
                    END;

                    BEGIN
                        SELECT NMMUNICIPIO, DSENDEFILI, NMBAIRFILI, ENDEFILI.SGESTADO, NRCEPFILI, NRTELEFILI, DSEMAILFILI, DSCOMPENDFIL
                        INTO V_NMMUNICIFILCC, V_DSENDEFILICC, V_NMBAIRFILICC, V_SGESTADOFILCC, V_NRCEPFILICC, V_NRTELEFILICC, V_DSEMAILFILICC, V_DSCOMPENDFILCC                        
                        FROM ENDEFILI INNER JOIN MUNICIPIO ON ENDEFILI.CDPAIS = MUNICIPIO.CDPAIS
                                                          AND ENDEFILI.SGESTADO = MUNICIPIO.SGESTADO
                                                          AND ENDEFILI.CDMUNICIPIO = MUNICIPIO.CDMUNICIPIO
                        WHERE ENDEFILI.IDTPENDEFILI = 'C'
                        AND ENDEFILI.CDFILIAL = C_AUTOFORNE.CDFILDEST;
                    EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                            V_NMMUNICIFILCC := NULL;
                            V_DSENDEFILICC := NULL;
                            V_NMBAIRFILICC := NULL;
                            V_SGESTADOFILCC := NULL;
                            V_NRCEPFILICC := NULL;
                            V_NRTELEFILICC := NULL;
                            V_DSEMAILFILICC := NULL;
                            V_DSCOMPENDFILCC := NULL;                            
                    END; 

                    BEGIN
                        SELECT CDFORMPGTO, NMFORMPGTO
                        INTO V_CDFORMPGTO, V_NMFORMPGTO
                        FROM FORMPGTO
                        WHERE CDFORMPGTO = C_AUTOFORNE.CDFORMPGTO;
                    EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                            V_CDFORMPGTO := NULL;
                            V_NMFORMPGTO := NULL;
                    END; 

                    IF (NVL(V_TIPO, '0') = '1') AND (C_ITEM.NMPRODUTO = 'PEDIDO_CANCELADO') THEN
                        V_TIPO := '2';
                    END IF;

                    V_PRAZOPGTAF := '';
                    IF NVL(C_AUTOFORNE.IDTPFORPGTAF, 'N') = 'V' THEN
                        FOR C_PRAZOPGTAF IN (SELECT CONCAT(CONCAT(CONCAT(' Nº:', NRDIASPGTOAF), CONCAT(' P:', VRPERCPGTOAF)), '%   /   ') FORMPGTOF
                                               FROM PRAZOPGTAF
                                              WHERE CDFILDEST  = C_AUTOFORNE.CDFILDEST
                                                AND CDFILLANC  = C_AUTOFORNE.CDFILLANC
                                                AND NRAUTOFORN = C_AUTOFORNE.NRAUTOFORN
                                            ORDER BY NRDIASPGTOAF)
                        LOOP
                            IF LENGTH(NVL(V_PRAZOPGTAF, '1')||C_PRAZOPGTAF.FORMPGTOF) < 1100 THEN
                                V_PRAZOPGTAF := V_PRAZOPGTAF||C_PRAZOPGTAF.FORMPGTOF;
                            ELSE
                                EXIT;
                            END IF;
                        END LOOP;
                    END IF;

                    IF LENGTH(V_PRAZOPGTAF) > 0 THEN
                        V_PRAZOPGTAF := SUBSTR(V_PRAZOPGTAF, 1, LENGTH(V_PRAZOPGTAF)-4);
                    END IF;
                    IF P_IDEXIBEOBSFIL = 'S' THEN
                        BEGIN
                            SELECT DSOBSFILIAL
                            INTO V_DSOBSFILIAL
                            FROM PARCMPSUP
                            WHERE CDFILIAL = C_ITEM.CDFILDEST;
                        EXCEPTION
                            WHEN NO_DATA_FOUND THEN BEGIN
                                V_DSOBSFILIAL  := NULL;
                            END;
                        END;

                        BEGIN
                            SELECT SUBSTR(LISTAGG(NRMENSAUTFOR||'|'||DSMENSAF,' - ') WITHIN GROUP (ORDER BY NRMENSAUTFOR), 1, 2000)
                            INTO V_DSMENSAUTF
                            FROM MENSAUTF
                            WHERE CDFILDEST  = C_ITEM.CDFILDEST
                                AND CDFILLANC  = C_ITEM.CDFILLANC
                                AND NRAUTOFORN = C_ITEM.NRAUTOFORN;
                        EXCEPTION
                            WHEN NO_DATA_FOUND THEN
                                V_DSMENSAUTF := ' ';
                        END;
                    END IF;

                    IF P_EXIBEAPENDICEUNIDADE = 'S' THEN
                        BEGIN
                            SELECT DSOBSUNIDADE
                            INTO V_DSOBSUNIDADE
                            FROM PARCMPSUP
                            WHERE CDFILIAL = C_ITEM.CDFILDEST;
                        EXCEPTION
                            WHEN NO_DATA_FOUND THEN BEGIN
                                V_DSOBSUNIDADE := NULL;
                            END;
                        END;
                    END IF;

                    BEGIN
                        SELECT LISTAGG(CDPRODUTOXML || ' / ') WITHIN GROUP (ORDER BY CDPRODUTOXML) AS PRODFORNE
                            INTO V_CDPRODUTOXML
                            FROM PRODFORNXML
                        WHERE CDPRODUTO  = C_ITEM.CDPRODUTO
                            AND CDFORNECED = C_AUTOFORNE.CDFORNECED;
                    EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                            V_CDPRODUTOXML := '';
                    END;

                    BEGIN
                        SELECT DSPRODUTO
                            INTO V_DSPRODUTO
                            FROM PRODFORNCOMP
                        WHERE CDPRODCOMPL  = C_ITEM.CDPRODUTO
                            AND CDFORNECED = C_AUTOFORNE.CDFORNECED;
                    EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                            V_DSPRODUTO := '';
                    END;                   

                    IF LENGTH(V_NMMUNICIFILEE||V_DSENDEFILIEE||V_NMBAIRFILIEE||V_SGESTADOFILEE||V_NRCEPFILIEE) = 0 THEN
                        V_NMMUNICIFIL   := V_NMMUNICIFIL;
                        V_DSENDEFILI    := V_DSENDEFILI;
                        V_NMBAIRFILI    := V_NMBAIRFILI;
                        V_SGESTADOFIL   := V_SGESTADOFIL;
                        V_NRCEPFILI     := V_NRCEPFILI;
                        V_NRTELEFILI    := V_NRTELEFILI;
                        V_DSEMAILFILI   := V_DSEMAILFILI;
                        V_DSCOMPENDFIL  := V_DSCOMPENDFIL;
                    ELSE
                        V_NMMUNICIFIL   := V_NMMUNICIFILEE;
                        V_DSENDEFILI    := V_DSENDEFILIEE;
                        V_NMBAIRFILI    := V_NMBAIRFILIEE;
                        V_SGESTADOFIL   := V_SGESTADOFILEE;
                        V_NRCEPFILI     := SUBSTR(REPLACE(V_NRCEPFILIEE, '-', ''),0,5)||'-'||SUBSTR(REPLACE(V_NRCEPFILIEE, '-', ''),6,3);
                        V_NRTELEFILI    := V_NRTELEFILIEE;
                        V_DSEMAILFILI   := V_DSEMAILFILIEE;
                        V_DSCOMPENDFIL  := V_DSCOMPENDFILEE;
                    END IF;

                    IF C_AUTOFORNE.IDTIPOEMITAF = '3' THEN
                        V_NMREPRINSEST   := V_NMRAZSOCCLIE;
                        V_NRINSJURIEST   := FORMATMASK(V_IDTPIJURCLIE, V_NRINSJURCLIE);
                        V_IDTPIJURIEST   := V_IDTPIJURCLIE;
                        V_DSENDEIEST     := V_DSENDECLIE;
                        V_NMBAIRIEST     := V_NMBAIRCLIE;
                        V_SGESTADOEST    := V_SGESTADOCLIE;
                        V_NRCEPIEST      := SUBSTR(REPLACE(V_NRCEPCLIE, '-', ''),0,5)||'-'||SUBSTR(REPLACE(V_NRCEPCLIE, '-', ''),6,3);
                        V_NMMUNICIPIOEST := V_NMMUNICLIE;
                        V_CDINSCESTA     := V_NRINSESTCLIE;

                        V_IDTPIJUREMPR   := V_IDTPIJURCLIE;
                        V_NRINSJUREMPR   := FORMATMASK(V_IDTPIJURCLIE, V_NRINSJURCLIE);
                        V_NMEMPRESA      := V_NMRAZSOCCLIE;
                        V_DSENDEEMPR     := V_DSENDECLIE;
                        V_NMBAIREMPR     := V_NMBAIRCLIE;
                        V_SGESTADOEMPR   := V_SGESTADOCLIE;
                        V_NRCEPEMPR      := SUBSTR(REPLACE(V_NRCEPCLIE, '-', ''),0,5)||'-'||SUBSTR(REPLACE(V_NRCEPCLIE, '-', ''),6,3);
                        V_NMMUNIEMPR     := V_NMMUNICLIE;
                        V_NRINSCESTAEMPR := V_NRINSESTCLIE;
                    ELSE
                        V_IDTPIJURIEST   := V_IDTPIJURIEST;
                        V_NRINSJURIEST   := FORMATMASK(V_IDTPIJURIEST, V_NRINSJURIEST);
                        V_NMREPRINSEST   := V_NMREPRINSEST;
                        V_DSENDEIEST     := V_DSENDEIEST;
                        V_NMBAIRIEST     := V_NMBAIRIEST;
                        V_SGESTADOEST    := V_SGESTADOEST;
                        V_NRCEPIEST      := SUBSTR(REPLACE(V_NRCEPIEST, '-', ''),0,5)||'-'||SUBSTR(REPLACE(V_NRCEPIEST, '-', ''),6,3);
                        V_NMMUNICIPIOEST := V_NMMUNICIPIOEST;
                        V_CDINSCESTA     := C_FILIAL.CDINSCESTA;

                        V_IDTPIJUREMPR   := V_IDTPIJUREMPR;
                        V_NRINSJUREMPR   := FORMATMASK(V_IDTPIJUREMPR, V_NRINSJUREMPR);
                        V_NMEMPRESA      := V_NMEMPRESA;
                        V_DSENDEEMPR     := V_DSENDEEMPR;
                        V_NMBAIREMPR     := V_NMBAIREMPR;
                        V_SGESTADOEMPR   := V_SGESTADOEMPR;
                        V_NRCEPEMPR      := SUBSTR(REPLACE(V_NRCEPEMPR, '-', ''),0,5)||'-'||SUBSTR(REPLACE(V_NRCEPEMPR, '-', ''),6,3);
                        V_NMMUNIEMPR     := V_NMMUNIEMPR;
                        V_NRINSCESTAEMPR := V_NRINSCESTAEMPR;
                    END IF;


                    FOR C_MODELO IN (SELECT NRENDERAUTOFORNE,
                                            CDFILIAL,
                                            IDENDENTREGAAF,
                                            IDENDFATURAMENTOAF,
                                            IDREPRESENTAFATAF,
                                            IDENDCOBRANCAAF,
                                            IDREPRESENTACOBRAAF
                                        FROM ENDERAUTOFORNE) LOOP
                        IF C_MODELO.IDENDENTREGAAF = '01' THEN
                            V_NMMUNICIFIL   := V_NMMUNICIFILEE;
                            V_DSENDEFILI    := V_DSENDEFILIEE;
                            V_NMBAIRFILI    := V_NMBAIRFILIEE;
                            V_SGESTADOFIL   := V_SGESTADOFILEE;
                            V_NRCEPFILI     := SUBSTR(REPLACE(V_NRCEPFILIEE, '-', ''),0,5)||'-'||SUBSTR(REPLACE(V_NRCEPFILIEE, '-', ''),6,3);
                            V_NRTELEFILI    := V_NRTELEFILIEE;
                            V_DSEMAILFILI   := V_DSEMAILFILIEE;
                            V_DSCOMPENDFIL  := V_DSCOMPENDFILEE;
                        ELSIF C_MODELO.IDENDENTREGAAF = '02' THEN
                            V_NMMUNICIFIL   := V_NMMUNICIFIL;
                            V_DSENDEFILI    := V_DSENDEFILI;
                            V_NMBAIRFILI    := V_NMBAIRFILI;
                            V_SGESTADOFIL   := V_SGESTADOFIL;
                            V_NRCEPFILI     := V_NRCEPFILI;
                            V_NRTELEFILI    := V_NRTELEFILI;
                            V_DSEMAILFILI   := V_DSEMAILFILI;
                            V_DSCOMPENDFIL  := V_DSCOMPENDFIL;
                        END IF;

                        IF C_MODELO.IDENDFATURAMENTOAF = 'NN' THEN
                            V_IDTPIJURIEST   := '';
                            V_NRINSJURIEST   := '';
                            V_DSENDEIEST     := '';
                            V_NMBAIRIEST     := '';
                            V_SGESTADOEST    := '';
                            V_NRCEPIEST      := '';
                            V_NMMUNICIPIOEST := '';
                            V_CDINSCESTA     := '';
                        ELSIF C_MODELO.IDENDFATURAMENTOAF = 'EP' THEN
                            V_IDTPIJURIEST   := V_IDTPIJURIEST;
                            V_NRINSJURIEST   := FORMATMASK(V_IDTPIJURIEST, V_NRINSJURIEST);
                            V_DSENDEIEST     := V_DSENDEIEST;
                            V_NMBAIRIEST     := V_NMBAIRIEST;
                            V_SGESTADOEST    := V_SGESTADOEST;
                            V_NRCEPIEST      := SUBSTR(REPLACE(V_NRCEPIEST, '-', ''),0,5)||'-'||SUBSTR(REPLACE(V_NRCEPIEST, '-', ''),6,3);
                            V_NMMUNICIPIOEST := V_NMMUNICIPIOEST;
                            V_CDINSCESTA     := C_FILIAL.CDINSCESTA;
                        ELSIF C_MODELO.IDENDFATURAMENTOAF = 'EE' THEN
                            V_IDTPIJURIEST   := V_IDTPIJUREMPR;
                            V_NRINSJURIEST   := FORMATMASK(V_IDTPIJUREMPR, V_NRINSJUREMPR);
                            V_DSENDEIEST     := V_DSENDEEMPR;
                            V_NMBAIRIEST     := V_NMBAIREMPR;
                            V_SGESTADOEST    := V_SGESTADOEMPR;
                            V_NRCEPIEST      := SUBSTR(REPLACE(V_NRCEPEMPR, '-', ''),0,5)||'-'||SUBSTR(REPLACE(V_NRCEPEMPR, '-', ''),6,3);
                            V_NMMUNICIPIOEST := V_NMMUNIEMPR;
                            V_CDINSCESTA     := V_NRINSCESTAEMPR;
                        ELSIF C_MODELO.IDENDFATURAMENTOAF = 'CL' THEN
                            V_IDTPIJURIEST   := V_IDTPIJURCLIE;
                            V_NRINSJURIEST   := FORMATMASK(V_IDTPIJURCLIE, V_NRINSJURCLIE);
                            V_DSENDEIEST     := V_DSENDECLIE;
                            V_NMBAIRIEST     := V_NMBAIRCLIE;
                            V_SGESTADOEST    := V_SGESTADOCLIE;
                            V_NRCEPIEST      := SUBSTR(REPLACE(V_NRCEPCLIE, '-', ''),0,5)||'-'||SUBSTR(REPLACE(V_NRCEPCLIE, '-', ''),6,3);
                            V_NMMUNICIPIOEST := V_NMMUNICLIE;
                            V_CDINSCESTA     := V_NRINSESTCLIE;
                        ELSIF C_MODELO.IDENDFATURAMENTOAF = 'IE' THEN
                            V_IDTPIJURIEST   := V_IDTPIJURIEST;
                            V_NRINSJURIEST   := FORMATMASK(V_IDTPIJURIEST, V_NRINSJURIEST);
                            V_DSENDEIEST     := V_DSENDEIEST;
                            V_NMBAIRIEST     := V_NMBAIRIEST;
                            V_SGESTADOEST    := V_SGESTADOEST;
                            V_NRCEPIEST      := SUBSTR(REPLACE(V_NRCEPIEST, '-', ''),0,5)||'-'||SUBSTR(REPLACE(V_NRCEPIEST, '-', ''),6,3);
                            V_NMMUNICIPIOEST := V_NMMUNICIPIOEST;
                            V_CDINSCESTA     := C_FILIAL.CDINSCESTA;
                        ELSIF C_MODELO.IDENDFATURAMENTOAF = 'FC' THEN
                            IF V_IDSISDOS <> '3' THEN
                                V_IDTPIJURIEST   := V_IDTPIJUREMPR;
                                V_NRINSJURIEST   := FORMATMASK(V_IDTPIJUREMPR, V_NRINSJUREMPR);
                                V_DSENDEIEST     := V_DSENDEEMPR;
                                V_NMBAIRIEST     := V_NMBAIREMPR;
                                V_SGESTADOEST    := V_SGESTADOEMPR;
                                V_NRCEPIEST      := SUBSTR(REPLACE(V_NRCEPEMPR, '-', ''),0,5)||'-'||SUBSTR(REPLACE(V_NRCEPEMPR, '-', ''),6,3);
                                V_NMMUNICIPIOEST := V_NMMUNIEMPR;
                                V_CDINSCESTA     := V_NRINSCESTAEMPR;
                            ELSE
                                IF C_AUTOFORNE.IDTIPOEMITAF = '3' THEN
                                    V_IDTPIJURIEST   := V_IDTPIJUREMPR;
                                    V_NRINSJURIEST   := FORMATMASK(V_IDTPIJUREMPR, V_NRINSJUREMPR);
                                    V_DSENDEIEST     := V_DSENDEEMPR;
                                    V_NMBAIRIEST     := V_NMBAIREMPR;
                                    V_SGESTADOEST    := V_SGESTADOEMPR;
                                    V_NRCEPIEST      := SUBSTR(REPLACE(V_NRCEPEMPR, '-', ''),0,5)||'-'||SUBSTR(REPLACE(V_NRCEPEMPR, '-', ''),6,3);
                                    V_NMMUNICIPIOEST := V_NMMUNIEMPR;
                                    V_CDINSCESTA     := V_NRINSCESTAEMPR;
                                END IF;
                            END IF;
                        END IF;

                        IF C_MODELO.IDENDCOBRANCAAF = 'NN' THEN
                            V_IDTPIJUREMPR   := '';
                            V_NRINSJUREMPR   := '';
                            V_DSENDEEMPR     := '';
                            V_NMBAIREMPR     := '';
                            V_SGESTADOEMPR   := '';
                            V_NRCEPEMPR      := '';
                            V_NMMUNIEMPR     := '';
                            V_NRINSCESTAEMPR := '';
                        ELSIF C_MODELO.IDENDCOBRANCAAF = 'EP' THEN
                            V_IDTPIJUREMPR   := C_FILIAL.IDTPIJURFILI;
                            V_NRINSJUREMPR   := FORMATMASK(C_FILIAL.IDTPIJURFILI, C_FILIAL.NRINSJURFILI);
                            V_NMEMPRESA      := C_FILIAL.NMFILIDEST;
                            V_DSENDEEMPR     := V_DSENDEFILI;
                            V_NMBAIREMPR     := V_NMBAIRFILI;
                            V_SGESTADOEMPR   := V_SGESTADOFIL;
                            V_NRCEPEMPR      := V_NRCEPFILI;
                            V_NMMUNIEMPR     := V_NMMUNICIFIL;
                            V_NRINSCESTAEMPR := C_FILIAL.CDINSCESTA;
                        ELSIF C_MODELO.IDENDCOBRANCAAF = 'EC' THEN
                            V_IDTPIJUREMPR   := C_FILIAL.IDTPIJURFILI;
                            V_NRINSJUREMPR   := FORMATMASK(C_FILIAL.IDTPIJURFILI, C_FILIAL.NRINSJURFILI);
                            V_NMEMPRESA      := C_FILIAL.NMFILIDEST;
                            V_DSENDEEMPR     := V_DSENDEFILICC;
                            V_NMBAIREMPR     := V_NMBAIRFILICC;
                            V_SGESTADOEMPR   := V_SGESTADOFILCC;
                            V_NRCEPEMPR      := SUBSTR(REPLACE(V_NRCEPFILICC, '-', ''),0,5)||'-'||SUBSTR(REPLACE(V_NRCEPFILICC, '-', ''),6,3);
                            V_NMMUNIEMPR     := V_NMMUNICIFILCC;
                            V_NRINSCESTAEMPR := C_FILIAL.CDINSCESTA;
                        ELSIF C_MODELO.IDENDCOBRANCAAF = 'EE' THEN
                            V_IDTPIJUREMPR   := V_IDTPIJUREMPR;
                            V_NRINSJUREMPR   := FORMATMASK(V_IDTPIJUREMPR, V_NRINSJUREMPR);
                            V_NMEMPRESA      := V_NMEMPRESA;
                            V_DSENDEEMPR     := V_DSENDEEMPR;
                            V_NMBAIREMPR     := V_NMBAIREMPR;
                            V_SGESTADOEMPR   := V_SGESTADOEMPR;
                            V_NRCEPEMPR      := SUBSTR(REPLACE(V_NRCEPEMPR, '-', ''),0,5)||'-'||SUBSTR(REPLACE(V_NRCEPEMPR, '-', ''),6,3);
                            V_NMMUNIEMPR     := V_NMMUNIEMPR;
                            V_NRINSCESTAEMPR := V_NRINSCESTAEMPR;
                        ELSIF C_MODELO.IDENDCOBRANCAAF = 'CL' THEN
                            V_IDTPIJUREMPR   := V_IDTPIJURCLIE;
                            V_NRINSJUREMPR   := FORMATMASK(V_IDTPIJURCLIE, V_NRINSJURCLIE);
                            V_NMEMPRESA      := V_NMRAZSOCCLIE;
                            V_DSENDEEMPR     := V_DSENDECLIE;
                            V_NMBAIREMPR     := V_NMBAIRCLIE;
                            V_SGESTADOEMPR   := V_SGESTADOCLIE;
                            V_NRCEPEMPR      := SUBSTR(REPLACE(V_NRCEPCLIE, '-', ''),0,5)||'-'||SUBSTR(REPLACE(V_NRCEPCLIE, '-', ''),6,3);
                            V_NMMUNIEMPR     := V_NMMUNICLIE;
                            V_NRINSCESTAEMPR := V_NRINSESTCLIE;
                        ELSIF C_MODELO.IDENDCOBRANCAAF = 'IE' THEN
                            V_NMEMPRESA      := V_NMREPRINSEST;
                            V_IDTPIJUREMPR   := V_IDTPIJURIEST;
                            V_NRINSJUREMPR   := FORMATMASK(V_IDTPIJURIEST, V_NRINSJURIEST);
                            V_DSENDEEMPR     := V_DSENDEIEST;
                            V_NMBAIREMPR     := V_NMBAIRIEST;
                            V_SGESTADOEMPR   := V_SGESTADOEST;
                            V_NRCEPEMPR      := SUBSTR(REPLACE(V_NRCEPIEST, '-', ''),0,5)||'-'||SUBSTR(REPLACE(V_NRCEPIEST, '-', ''),6,3);
                            V_NMMUNIEMPR     := V_NMMUNICIPIOEST;
                            V_NRINSCESTAEMPR := C_FILIAL.CDINSCESTA;
                        END IF;

                        IF C_MODELO.IDREPRESENTAFATAF = 'NN' THEN
                            V_NMREPRINSEST   := '';
                        ELSIF C_MODELO.IDREPRESENTAFATAF = 'NF' THEN
                            V_NMREPRINSEST   := C_FILIAL.NMFILIDEST;
                        ELSIF C_MODELO.IDREPRESENTAFATAF = 'RF' THEN
                            V_NMREPRINSEST   := C_FILIAL.NMRAZSOCFILI;
                        ELSIF C_MODELO.IDREPRESENTAFATAF = 'EP' THEN
                            V_NMREPRINSEST   := V_NMREPRINSEST;
                        ELSIF C_MODELO.IDREPRESENTAFATAF = 'CL' THEN
                            V_NMREPRINSEST   := V_NMRAZSOCCLIE;
                        ELSIF C_MODELO.IDREPRESENTAFATAF = 'EE' THEN
                            V_NMREPRINSEST   := V_NMEMPRESA;
                        ELSIF C_MODELO.IDREPRESENTAFATAF = 'FC' THEN
                            IF V_IDSISDOS <> '3' THEN
                                V_NMREPRINSEST   := V_NMEMPRESA;
                            ELSE
                                IF C_AUTOFORNE.IDTIPOEMITAF = '3' THEN
                                    V_NMREPRINSEST   := V_NMEMPRESA;
                                END IF;
                            END IF;
                        END IF;

                        IF C_MODELO.IDREPRESENTACOBRAAF  = 'NN' THEN
                            V_NMEMPRESA   := '';
                        ELSIF C_MODELO.IDREPRESENTACOBRAAF  = 'NF' THEN
                            V_NMEMPRESA   := C_FILIAL.NMFILIDEST;
                        ELSIF C_MODELO.IDREPRESENTACOBRAAF  = 'RF' THEN
                            V_NMEMPRESA   := C_FILIAL.NMRAZSOCFILI;
                        ELSIF C_MODELO.IDREPRESENTACOBRAAF  = 'EP' THEN
                            V_NMEMPRESA   := V_NMREPRINSEST;
                        ELSIF C_MODELO.IDREPRESENTACOBRAAF  = 'CL' THEN
                            V_NMEMPRESA   := V_NMRAZSOCCLIE;
                        ELSIF C_MODELO.IDREPRESENTACOBRAAF  = 'EE' THEN
                            V_NMEMPRESA   := V_NMEMPRESA;
                        END IF;

                        V_IDENDFATURAMENTOAF  := C_MODELO.IDENDFATURAMENTOAF;
                        V_IDREPRESENTAFATAF   := C_MODELO.IDREPRESENTAFATAF;
                        V_IDENDCOBRANCAAF     := C_MODELO.IDENDCOBRANCAAF;
                        V_IDREPRESENTACOBRAAF := C_MODELO.IDREPRESENTACOBRAAF;

                        IF NVL(P_IDDTUTILIZACAO, 'N') = 'S' THEN
                            SELECT NVL(MIN(I.DTUTILIZA), C_ITEM.DTPROGENTAF)
                            INTO V_DTUTILIZACAO
                            FROM ITEMSOLI I, PRODUTO  P
                            WHERE I.CDFILSOLI = C_ITEM.CDFILDEST
                                AND I.CDPRODUTO = P.CDPRODUTO
                                AND P.CDPRODESTO = C_ITEM.CDPRODESTO
                                AND NVL(I.IDITMCONS, 'N') = 'N'
                                AND NVL(I.IDSOLIAPROV, 'S') = 'S'
                                AND NVL(I.CDFILIOPELOG, 'W') <> 'W'
                                AND NVL(I.IDITMSOLEXTRA, 'N') = NVL(C_AUTOFORNE.IDAUTOFORNEX, 'N')
                                AND I.DTPROGENTR = C_ITEM.DTENTRITMSOL;
                        END IF;
                    END LOOP;

                    L_RELATORIO_AF_EMAIL_TYPE := RELATORIO_AF_EMAIL_TYPE (
                        C_AUTOFORNE.CDFILDEST,                      --01
                        C_AUTOFORNE.NRSEQAPURAF,                    --02
                        C_FILIAL.NMFILIDEST,                        --03
                        C_AUTOFORNE.CDFILLANC,                      --04
                        C_AUTOFORNE.NRAUTOFORN,                     --05
                        C_AUTOFORNE.CDOPERADOR,                     --06
                        V_CDFORNECED,                               --07
                        C_AUTOFORNE.VRTOTALAF,                      --08
                        C_AUTOFORNE.DTAUTOFORN,                     --09
                        C_AUTOFORNE.IDTIPOEMITAF,                   --10
                        V_NMEMPRESA,                                --11
                        V_SGESTADOEMPR,                             --12
                        V_NRCEPEMPR,                                --13
                        V_DSENDEEMPR,                               --14
                        V_NMMUNIEMPR,                               --15
                        V_IDTPIJUREMPR,                             --16
                        V_NRINSJUREMPR,                             --17
                        V_NMBAIREMPR,                               --18
                        C_FILIAL.NMFILIDEST,                        --19
                        C_FILIAL.NRINSJURFILI,                      --20
                        C_FILIAL.IDTPIJURFILI,                      --21
                        C_FILIAL.NMRAZSOCFILI,                      --22
                        V_DSPERIENTFIL,                             --23
                        NVL(P_IMPRIMEOBSPROD, 'N'),                 --24
                        V_CDINSCESTA,                               --25
                        V_NRINSCESTAEMPR,                           --26
                        V_CDFORMPGTO,                               --27
                        C_AUTOFORNE.IDTPFORPGTAF,                   --28
                        C_AUTOFORNE.NRDIAPGFIXAF,                   --29
                        C_AUTOFORNE.NRPARCPGTOAF,                   --30
                        C_AUTOFORNE.IDSITUATUAAF,                   --31
                        C_AUTOFORNE.IDIMAUTOFORN,                   --32
                        C_AUTOFORNE.IDTIPOFRETAF,                   --33
                        C_AUTOFORNE.IDAUTOFORNEX,                   --34
                        C_AUTOFORNE.IDTIPOLANCAF,                   --35
                        C_AUTOFORNE.IDAFFORALIM,                    --36
                        C_AUTOFORNE.IDBAIXAAF,                      --37
                        V_IDTPIJURFORN,                             --38
                        FORMATMASK(V_IDTPIJURFORN, V_NRINSJURFORN), --39
                        V_NMRAZSOCFORN,                             --40
                        V_NMRAZSOCFORN||' | '||V_NMFANTFORN,        --41
                        V_DSENDEFORN,                               --42
                        V_NMCONTFORN,                               --43
                        V_NRTELEFORN1,                              --44
                        V_NRTELEFORN,                               --45
                        V_DSEMAILCOT,                               --46
                        V_IDTPIJURCLIE,                             --47
                        FORMATMASK(V_IDTPIJURCLIE, V_NRINSJURCLIE), --48
                        V_NMRAZSOCCLIE,                             --49
                        V_DSENDECLIE,                               --50
                        V_NMBAIRCLIE,                               --51
                        V_SGESTADOCLIE,                             --52
                        SUBSTR(REPLACE(V_NRCEPCLIE, '-', ''),0,5)||'-'||SUBSTR(REPLACE(V_NRCEPCLIE, '-', ''),6,3), --53
                        V_NRINSESTCLIE,                             --54
                        V_NMMUNICLIE,                               --55
                        V_CDCLIENTE,                                --56
                        V_NMOPERADOR,                               --57
                        V_NMMUNICIFIL,                              --58
                        V_DSENDEFILI,                               --59
                        V_NMBAIRFILI,                               --60
                        V_SGESTADOFIL,                              --61
                        SUBSTR(REPLACE(V_NRCEPFILI, '-', ''),0,5)||'-'||SUBSTR(REPLACE(V_NRCEPFILI, '-', ''),6,3), --62
                        V_NRTELEFILI,                                   --63
                        V_DSEMAILFILI,                                  --64
                        C_ITEM.DTPROGENTAF,                             --65
                        C_ITEM.CDPRODUTO,                               --66
                        C_ITEM.QTPROGENTAF,                             --67
                        C_ITEM.VRPREUNIAF,                              --68
                        C_ITEM.VALTOTAL,                                --69
                        C_ITEM.CDARVPROD,                               --70
                        C_ITEM.NMPRODUTO,                               --71
                        C_ITEM.CDMARCA,                                 --72
                        C_ITEM.NMMARCA,                                 --73
                        V_CDSEGMARCA,                                   --74
                        V_NMSEGMARCA,                                   --75
                        C_ITEM.TXOBSITMAF,                              --76
                        V_PRAZOPGTAF,                                   --77
                        V_NMFORMPGTO,                                   --78
                        SUBSTR((V_DSOBSFILIAL||V_DSMENSAUTF), 1, 2000), --79
                        V_DSOBSUNIDADE,                                 --80
                        P_IDEXIBEOBSFIL,                                --81
                        V_NMREPRINSEST,                                 --82
                        V_NRINSJURIEST,                                 --83
                        V_IDTPIJURIEST,                                 --84
                        V_DSENDEIEST,                                   --85
                        V_NMBAIRIEST,                                   --86
                        V_SGESTADOEST,                                  --87
                        V_NRCEPIEST,                                    --88
                        V_NMMUNICIPIOEST,                               --89
                        V_IDENDFATURAMENTOAF,                           --90
                        V_IDREPRESENTAFATAF,                            --91
                        V_IDENDCOBRANCAAF,                              --92
                        V_IDREPRESENTACOBRAAF,                          --93
                        V_CDPRODUTOXML,                                 --94
                        V_DSPRODUTO,                                    --95
                        V_DSCOMPENDFIL,                                 --96
                        C_AUTOFORNE.IDUTDIAPGTAF,                       --97
                        V_DSMENSAUTF,                                   --98
                        NVL(P_EXIBEAPENDICEUNIDADE, 'N'),               --99
                        C_ITEM.IDTIPOLANITM,                            --100
                        V_TIPO,                                         --101
                        V_DTUTILIZACAO);                                --102
                    PIPE ROW (L_RELATORIO_AF_EMAIL_TYPE);
                END IF;
            END LOOP;
        END LOOP;
    END LOOP;
    RETURN;
END RELATORIO_AF_EMAIL;
/