/*===-  Criação dos Types para Function  -===*/

DROP TYPE FCT_ESTIMADO_MAPAFATURA_TABLE;
/

DROP TYPE FCT_ESTIMADO_MAPAFATURA_TYPE;
/

CREATE OR REPLACE TYPE FCT_ESTIMADO_MAPAFATURA_TYPE AS OBJECT
   (CDSERVORCA    NUMBER,
    NMSERVORCA    VARCHAR2(1000),
    NRPARCNEGOCIO NUMBER,
	NMPARCEIRO    VARCHAR2(1000),
	NRSEQCONTRATO NUMBER,
	CONTRATO      VARCHAR2(100),
	COMPETENCIA1  VARCHAR2(10),
    ESTIMADO1     NUMBER,
	FATURADO1     NUMBER,
	DIFERENCA1    NUMBER,
	DESVIO1       NUMBER,
    COMPETENCIA2  VARCHAR2(10),
	ESTIMADO2     NUMBER,
	FATURADO2     NUMBER,
	DIFERENCA2    NUMBER,
	DESVIO2       NUMBER,
	COMPETENCIA3  VARCHAR2(10),
    ESTIMADO3     NUMBER,
	FATURADO3     NUMBER,
	DIFERENCA3    NUMBER,
	DESVIO3       NUMBER,
    NRORG         NUMBER,
    DTINCLUSAO    DATE);
/

CREATE OR REPLACE TYPE FCT_ESTIMADO_MAPAFATURA_TABLE AS TABLE OF FCT_ESTIMADO_MAPAFATURA_TYPE;
/


/*===-  Criação da Function FCT_ESTIMADO_MAPAFATURA  -===*/

CREATE OR REPLACE FUNCTION FCT_ESTIMADO_MAPAFATURA(P_TIPO IN VARCHAR2,
												   P_TPESTIMADO IN VARCHAR2,
                                                   P_CDSERVORCA IN FCT_SERVICOORCA.CDSERVORCA%TYPE,
												   P_PARCNEGOCIO IN PARCNEGOCIO.NRPARCNEGOCIO%TYPE,
												   P_NRORG IN FCT_CONTRATO.NRORG%TYPE)

/* P_TIPO: 'SERVICO' / 'PARCEIRO' / 'CONTRATO' / 'EXPORTACAO' */

RETURN FCT_ESTIMADO_MAPAFATURA_TABLE PIPELINED
IS
OUT_RECORD FCT_ESTIMADO_MAPAFATURA_TYPE := FCT_ESTIMADO_MAPAFATURA_TYPE (NULL, NULL, NULL, NULL, NULL, NULL,
                                                                         NULL, NULL, NULL, NULL, NULL, NULL,
                                                                         NULL, NULL, NULL, NULL, NULL, NULL,
                                                                         NULL, NULL, NULL, NULL, NULL);
V_SERVICOANTE          NUMBER;
V_PARCEIROANTE         NUMBER;
V_CONTRATOANTE         NUMBER;
V_VRMEDICAO            NUMBER;
V_VALORAUX             NUMBER;
V_VALORAUX2            NUMBER;
V_VALORAUX3            NUMBER;
V_VALORFATAUX          NUMBER;
V_VALORFATAUX2         NUMBER;
V_VALORFATAUX3         NUMBER;
V_VRFATURA             NUMBER;
V_VRFATURA2            NUMBER;
V_VRFATURA3            NUMBER;
V_VRDIFF               NUMBER;
V_VRDIFF2              NUMBER;
V_VRDIFF3              NUMBER;
V_DESVIO               NUMBER;
V_DESVIO2              NUMBER;
V_DESVIO3              NUMBER;
V_VALORSERV            NUMBER;
V_VALORSERV2           NUMBER;
V_VALORSERV3           NUMBER;
V_VALORPARC            NUMBER;
V_VALORPARC2           NUMBER;
V_VALORPARC3           NUMBER;
V_VALORCONTR           NUMBER;
V_VALORCONTR2          NUMBER; 
V_VALORCONTR3          NUMBER;
V_DESCONTONEG          NUMBER;
V_DESCPERIODO          NUMBER;
V_QTPARCELA            NUMBER;
V_IDTIPONEGOCIA        VARCHAR2(2);
V_VRPARCELANEGOCIA     NUMBER;
V_IDREALIZARNEGOCIACAO VARCHAR2(1);
V_POSINI               NUMBER;
V_DTPERIODO            VARCHAR2(20);
V_PERIODO              VARCHAR2(20);
V_PERIODO2             VARCHAR2(20);
V_PERIODO3             VARCHAR2(20);
V_NMSERVANTE           VARCHAR2(500);
V_NMPARCANTE           VARCHAR2(500);
V_CODCONTRANTE         VARCHAR2(100);
V_NRFATURACONT         NUMBER;

V_SERVICOANTEPARC      NUMBER;
V_NMSERVANTEPARC       VARCHAR2(500);

V_SERVICOANTECONT      NUMBER;
V_NMSERVANTECONT       VARCHAR2(500);
V_PARCEIROANTECONT     NUMBER;
V_NMPARCANTECONT       VARCHAR2(500);

BEGIN
	
	V_SERVICOANTE  := -1;
	V_PARCEIROANTE := -1;
    V_CONTRATOANTE := -1;
	
	V_NMSERVANTE   := NULL;
	V_NMPARCANTE   := NULL;
	V_CODCONTRANTE := NULL;
	
	V_VRMEDICAO    := 0;
	
	V_VALORAUX     := 0;
	V_VALORAUX2    := 0;
	V_VALORAUX3    := 0;
	
	V_VALORFATAUX  := 0;
	V_VALORFATAUX2 := 0;
	V_VALORFATAUX3 := 0;
	
	V_VRFATURA     := 0;
	V_VRFATURA2    := 0;
	V_VRFATURA3    := 0;
	
	V_VRDIFF       := 0;
	V_VRDIFF2      := 0;
	V_VRDIFF3      := 0;
	
	V_DESVIO       := 0;
	V_DESVIO2      := 0;
	V_DESVIO3      := 0;
	
	V_VALORSERV    := 0;
	V_VALORSERV2   := 0;
	V_VALORSERV3   := 0;
	
    V_VALORPARC    := 0;
	V_VALORPARC2   := 0;
	V_VALORPARC3   := 0;
	
    V_VALORCONTR   := 0;
    V_VALORCONTR2  := 0; 
	V_VALORCONTR3  := 0;
	
	V_PERIODO  := TO_CHAR(ADD_MONTHS(SYSDATE, -1), 'MM/YYYY');
	V_PERIODO2 := TO_CHAR(ADD_MONTHS(SYSDATE,-2), 'MM/YYYY');
	V_PERIODO3 := TO_CHAR(ADD_MONTHS(SYSDATE,-3), 'MM/YYYY');
	
	FOR C_CALC IN (SELECT DISTINCT BASE.CDSERVORCA, BASE.NMSERVORCA, BASE.NRPARCFATURA, BASE.NMPARCEIRO, BASE.NRSEQCONTRATO, 
                          BASE.NRCONTRATOFCT, BASE.NRITEMOCONTRATO, BASE.IDTPFATURA,
                          MES1.PERIODO, NVL(MES1.VRCONT, 0) AS VRCONT, MES1.NRFATURACONT, NVL(MES1.VRFATURADO,0) AS VRFATURADO,
                          MES2.PERIODO AS PERIODO2, NVL(MES2.VRCONT,0) AS VRCONT2, MES2.NRFATURACONT AS NRFATURACONT2, NVL(MES2.VRFATURADO,0) AS VRFATURADO2,
						  MES3.PERIODO AS PERIODO3, NVL(MES3.VRCONT,0) AS VRCONT3, MES3.NRFATURACONT AS NRFATURACONT3, NVL(MES3.VRFATURADO,0) AS VRFATURADO3
					 FROM (SELECT DISTINCT ITCONT.CDSERVORCA, SERV.NMSERVORCA, FAT.NRPARCFATURA, PARC.NMPRINCIPALPARC||'( '||PARC.NMSECUNDARIPARC||' )' AS NMPARCEIRO,
                           CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT, ITCONT.NRITEMOCONTRATO, FAT.IDTPFATURA
                         FROM FCT_FATURACONT FAT
							 JOIN FCT_ITFATURACONT ITEM
							   ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
							  AND ITEM.NRORG = FAT.NRORG
							 JOIN FCT_ITEMCONTRATO ITCONT
							   ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
							  AND ITCONT.NRORG = ITEM.NRORG
							 JOIN FCT_CONTRATO CONT
							   ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
							  AND CONT.NRORG = ITCONT.NRORG
                             JOIN PARCNEGOCIO PARC
                               ON PARC.NRPARCNEGOCIO =  FAT.NRPARCFATURA
                             JOIN FCT_SERVICOORCA SERV
                               ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
							WHERE ((TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -1), 'MM/YYYY'))
                                    OR (TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -2), 'MM/YYYY'))
                                    OR(TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -3), 'MM/YYYY')))
							  AND ((P_TIPO = 'SERVICO')
                                    OR (P_TIPO = 'EXPORTACAO')							  
									OR ((P_TIPO = 'PARCEIRO') AND (ITCONT.CDSERVORCA = P_CDSERVORCA))
									OR ((P_TIPO = 'CONTRATO') AND (ITCONT.CDSERVORCA = P_CDSERVORCA) AND (FAT.NRPARCFATURA = P_PARCNEGOCIO)))
							  AND FAT.NRORG = P_NRORG 
							ORDER BY ITCONT.CDSERVORCA, FAT.NRPARCFATURA, CONT.NRSEQCONTRATO) BASE
                                    
                     LEFT JOIN (SELECT FAT.NRPARCFATURA, CONT.NRSEQCONTRATO, ITEM.NRITEMOCONTRATO, ITCONT.CDSERVORCA, FAT.NRFATURACONT, 
								  ITCONT.NMITEMCONTRATO, TO_CHAR(ADD_MONTHS(SYSDATE, -1), 'MM/YYYY') AS PERIODO, ITCONT.VRTOTITEMCONT AS VRCONT, 
								  DECODE(FAT.IDSITUACAO, 3, ITEM.VRFATURADO, 0) AS VRFATURADO 
							 FROM FCT_FATURACONT FAT
							 JOIN FCT_ITFATURACONT ITEM
							   ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
							  AND ITEM.NRORG = FAT.NRORG
							 JOIN FCT_ITEMCONTRATO ITCONT
							   ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
							  AND ITCONT.NRORG = ITEM.NRORG
							 JOIN FCT_CONTRATO CONT
							   ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
							  AND CONT.NRORG = ITCONT.NRORG
							WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE, -1), 'MM/YYYY')
							  AND ((P_TIPO = 'SERVICO') 
							        OR (P_TIPO = 'EXPORTACAO')   
									OR ((P_TIPO = 'PARCEIRO') AND (ITCONT.CDSERVORCA = P_CDSERVORCA))
									OR ((P_TIPO = 'CONTRATO') AND (ITCONT.CDSERVORCA = P_CDSERVORCA) AND (FAT.NRPARCFATURA = P_PARCNEGOCIO)))
							  AND FAT.NRORG = P_NRORG 
							ORDER BY ITCONT.CDSERVORCA, FAT.NRPARCFATURA, CONT.NRSEQCONTRATO) MES1
                            ON BASE.CDSERVORCA =  MES1.CDSERVORCA
					   AND BASE.NRPARCFATURA =  MES1.NRPARCFATURA
					   AND BASE.NRSEQCONTRATO = MES1.NRSEQCONTRATO
                       
					 /*MÊS 2*/
					 LEFT JOIN (SELECT FAT.NRPARCFATURA, CONT.NRSEQCONTRATO, ITEM.NRITEMOCONTRATO, ITCONT.CDSERVORCA, FAT.NRFATURACONT, 
								  ITCONT.NMITEMCONTRATO, TO_CHAR(ADD_MONTHS(SYSDATE,-2), 'MM/YYYY') AS PERIODO, ITCONT.VRTOTITEMCONT AS VRCONT, 
								  DECODE(FAT.IDSITUACAO, 3, ITEM.VRFATURADO, 0) AS VRFATURADO
							 FROM FCT_FATURACONT FAT
							 JOIN FCT_ITFATURACONT ITEM
							   ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
							  AND ITEM.NRORG = FAT.NRORG
							 JOIN FCT_ITEMCONTRATO ITCONT
							   ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
							  AND ITCONT.NRORG = ITEM.NRORG
							 JOIN FCT_CONTRATO CONT
							   ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
							  AND CONT.NRORG = ITCONT.NRORG
							WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE,-2), 'MM/YYYY')
							  AND ((P_TIPO = 'SERVICO') 
							        OR (P_TIPO = 'EXPORTACAO') 
									OR ((P_TIPO = 'PARCEIRO') AND (ITCONT.CDSERVORCA = P_CDSERVORCA))
									OR ((P_TIPO = 'CONTRATO') AND (ITCONT.CDSERVORCA = P_CDSERVORCA) AND (FAT.NRPARCFATURA = P_PARCNEGOCIO)))
                              AND FAT.NRORG = P_NRORG 
							ORDER BY ITCONT.CDSERVORCA, FAT.NRPARCFATURA, CONT.NRSEQCONTRATO) MES2
						ON BASE.CDSERVORCA =  MES2.CDSERVORCA
					   AND BASE.NRPARCFATURA =  MES2.NRPARCFATURA
					   AND BASE.NRSEQCONTRATO = MES2.NRSEQCONTRATO
                       
					 /*MÊS 3*/
					 LEFT JOIN (SELECT FAT.NRPARCFATURA, CONT.NRSEQCONTRATO, ITEM.NRITEMOCONTRATO, ITCONT.CDSERVORCA, FAT.NRFATURACONT, 
								  ITCONT.NMITEMCONTRATO, TO_CHAR(ADD_MONTHS(SYSDATE,-3), 'MM/YYYY') AS PERIODO, ITCONT.VRTOTITEMCONT AS VRCONT, 
								  DECODE(FAT.IDSITUACAO, 3, ITEM.VRFATURADO, 0) AS VRFATURADO
							 FROM FCT_FATURACONT FAT
							 JOIN FCT_ITFATURACONT ITEM
							   ON ITEM.NRFATURACONT = FAT.NRFATURACONT 
							  AND ITEM.NRORG = FAT.NRORG
							 JOIN FCT_ITEMCONTRATO ITCONT
							   ON ITCONT.NRITEMOCONTRATO = ITEM.NRITEMOCONTRATO
							  AND ITCONT.NRORG = ITEM.NRORG
							 JOIN FCT_CONTRATO CONT
							   ON CONT.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
							  AND CONT.NRORG = ITCONT.NRORG
							WHERE TO_CHAR(FAT.DTFINCOMPET , 'MM/YYYY') = TO_CHAR(ADD_MONTHS(SYSDATE,-3), 'MM/YYYY')
                              AND ((P_TIPO = 'SERVICO') 
							        OR (P_TIPO = 'EXPORTACAO')
									OR ((P_TIPO = 'PARCEIRO') AND (ITCONT.CDSERVORCA = P_CDSERVORCA))
									OR ((P_TIPO = 'CONTRATO') AND (ITCONT.CDSERVORCA = P_CDSERVORCA) AND (FAT.NRPARCFATURA = P_PARCNEGOCIO)))
							  AND FAT.NRORG = P_NRORG 
							ORDER BY ITCONT.CDSERVORCA, FAT.NRPARCFATURA, CONT.NRSEQCONTRATO) MES3	
						ON BASE.CDSERVORCA =  MES3.CDSERVORCA
					   AND BASE.NRPARCFATURA =  MES3.NRPARCFATURA
					   AND BASE.NRSEQCONTRATO = MES3.NRSEQCONTRATO
					 ORDER BY BASE.CDSERVORCA,BASE.NRPARCFATURA, BASE.NRSEQCONTRATO) LOOP

		IF ((C_CALC.IDTPFATURA = 'X') AND (P_TPESTIMADO = 'MEDICAO')) THEN
			V_POSINI:= 1;
			WHILE (V_POSINI <= 3) LOOP
			
				IF V_POSINI = 1 THEN
					V_NRFATURACONT := C_CALC.NRFATURACONT;
				END IF;
				IF V_POSINI = 2 THEN
					V_NRFATURACONT := C_CALC.NRFATURACONT2;
				END IF;
				IF V_POSINI = 3 THEN
					V_NRFATURACONT := C_CALC.NRFATURACONT3;
				END IF;
				
				BEGIN           
					SELECT NVL(ITMED.VRITEMCONT,0) AS VRMEDICAO
					  INTO V_VRMEDICAO
					  FROM FCT_RELACAGRUPCONTFAT REL 
					  JOIN FCT_ITMEDICAOFATURA ITMED
						ON ITMED.CDSERVORCA =  C_CALC.CDSERVORCA
					   AND ITMED.NRSEQCONTRATO	= C_CALC.NRSEQCONTRATO
					   AND ITMED.NRITEMOCONTRATO = C_CALC.NRITEMOCONTRATO	
					   AND ITMED.NRMEDICAOFATURA = REL.NRMEDICAOFATURA
					   AND ITMED.IDSITUACAO = '3'
					   AND ITMED.NRORG = REL.NRORG 
					 WHERE REL.NRFATURACONT = V_NRFATURACONT 
					   AND REL.NRORG = P_NRORG;
				EXCEPTION
					WHEN NO_DATA_FOUND THEN
						V_VRMEDICAO := 0;
				END;
				
				
				IF V_POSINI = 1 THEN
					V_VALORAUX := V_VRMEDICAO;
				END IF;
				IF V_POSINI = 2 THEN
					V_VALORAUX2 := V_VRMEDICAO;
				END IF;
				IF V_POSINI = 3 THEN
					V_VALORAUX3 := V_VRMEDICAO;
				END IF;
				
				V_POSINI := V_POSINI+1;
			
			END LOOP;
		ELSE
			V_VALORAUX := C_CALC.VRCONT;
			V_VALORAUX2 := C_CALC.VRCONT2;
			V_VALORAUX3 := C_CALC.VRCONT3;
		END IF;
		
		
		V_VALORFATAUX  := C_CALC.VRFATURADO;
		V_VALORFATAUX2 := C_CALC.VRFATURADO2;
		V_VALORFATAUX3 := C_CALC.VRFATURADO3;
		
		/* 1 - Calcula o desconto da negociação de valores (negociação e item)*/
		IF ((C_CALC.IDTPFATURA <> 'X') OR ((C_CALC.IDTPFATURA = 'X') AND (P_TPESTIMADO <> 'MEDICAO'))) THEN
			
			BEGIN
				SELECT DECODE(NVL(ITNEG.VRPERCDESCITEM,0), 0, NVL(NEG.VRPERCDESCITEM,0), NVL(ITNEG.VRPERCDESCITEM,0))
				  INTO V_DESCONTONEG
				  FROM FCT_NEGOCIACAOCONTRATO NEG
				  JOIN FCT_ITNEGOCIACAOCONTRATO ITNEG
					ON ITNEG.NRNEGOCIACAOCONTRATO = NEG.NRNEGOCIACAOCONTRATO
				   AND ITNEG.NRORG = NEG.NRORG
				 WHERE ITNEG.NRITEMOCONTRATO = C_CALC.NRITEMOCONTRATO
				   AND NEG.NRPARCFATURA = C_CALC.NRPARCFATURA
				   AND NEG.NRSEQCONTRATO = C_CALC.NRSEQCONTRATO
				   AND NEG.NRORG = P_NRORG;
			EXCEPTION
				WHEN NO_DATA_FOUND THEN
					V_DESCONTONEG := 0;
			END;
		
			IF (V_DESCONTONEG > 0) THEN
				V_VALORAUX  := V_VALORAUX - ((V_VALORAUX*V_DESCONTONEG)/100);
				V_VALORAUX2 := V_VALORAUX2 - ((V_VALORAUX2*V_DESCONTONEG)/100);
				V_VALORAUX3 := V_VALORAUX3 - ((V_VALORAUX3*V_DESCONTONEG)/100);
			END IF;
		END IF;
		
		/* 2 - Se houver parcelamento, calcula o valor do parcelamento  (Somente para itens do tipo Parcelamento) */
		BEGIN
			SELECT COUNT(*) AS QTPARCELA
			INTO V_QTPARCELA 
			FROM FCT_PARCELANEGOCONT PARCELA
			JOIN FCT_NEGOCIACAOCONTRATO NEG
			  ON NEG.NRNEGOCIACAOCONTRATO = PARCELA.NRNEGOCIACAOCONTRATO
			 AND NEG.NRORG = PARCELA.NRORG
			JOIN FCT_ITNEGOCIACAOCONTRATO ITNEG
			  ON ITNEG.NRNEGOCIACAOCONTRATO = NEG.NRNEGOCIACAOCONTRATO
			 AND ITNEG.NRORG = NEG.NRORG
		   WHERE ITNEG.NRITEMOCONTRATO = C_CALC.NRITEMOCONTRATO
			 AND NEG.NRPARCFATURA = C_CALC.NRPARCFATURA
			 AND NEG.NRSEQCONTRATO = C_CALC.NRSEQCONTRATO
			AND NEG.NRORG = P_NRORG;
		EXCEPTION
			WHEN NO_DATA_FOUND THEN
				V_QTPARCELA := 0;
		END;
		
		IF (V_QTPARCELA > 0) THEN
			V_VALORAUX  := V_VALORAUX/V_QTPARCELA;
			V_VALORAUX2 := V_VALORAUX2/V_QTPARCELA;
			V_VALORAUX3 := V_VALORAUX3/V_QTPARCELA;
		END IF;
		
		V_POSINI:= 1;
		WHILE (V_POSINI <= 3) LOOP /* LOOP DAS DATAS - TEM QUE SER CALCULADO PARA CADA PERIODO SEPARADAMENTE*/
		
			IF V_POSINI = 1 THEN
				V_DTPERIODO := '01/'||V_PERIODO;
				V_NRFATURACONT := C_CALC.NRFATURACONT;
			END IF;
			IF V_POSINI = 2 THEN
			    V_DTPERIODO := '01/'||V_PERIODO2;
				V_NRFATURACONT := C_CALC.NRFATURACONT2;
			END IF;
			IF V_POSINI = 3 THEN
			    V_DTPERIODO := '01/'||V_PERIODO3;
				V_NRFATURACONT := C_CALC.NRFATURACONT3;
			END IF;
			
			/* 3 - Calcula o desconto por período (Somente para os itens de faturamento periódico) */
			IF ((C_CALC.IDTPFATURA <> 'X') OR ((C_CALC.IDTPFATURA = 'X') AND (P_TPESTIMADO <> 'MEDICAO'))) THEN
				BEGIN
					SELECT NVL(DESCPER.VRPERCDESCITEM, 0)
					  INTO V_DESCPERIODO
					  FROM FCT_DESCPERIODONEGOCONT DESCPER
					  JOIN FCT_NEGOCIACAOCONTRATO NEG
						ON NEG.NRNEGOCIACAOCONTRATO = DESCPER.NRNEGOCIACAOCONTRATO
					   AND NEG.NRORG = DESCPER.NRORG
					  JOIN FCT_ITNEGOCIACAOCONTRATO ITNEG
						ON ITNEG.NRNEGOCIACAOCONTRATO = NEG.NRNEGOCIACAOCONTRATO
					   AND ITNEG.NRORG = NEG.NRORG
					 WHERE ITNEG.NRITEMOCONTRATO = C_CALC.NRITEMOCONTRATO
					   AND NEG.NRPARCFATURA = C_CALC.NRPARCFATURA
					   AND NEG.NRSEQCONTRATO = C_CALC.NRSEQCONTRATO
					   AND NEG.NRORG = P_NRORG
					   AND DTFINALVALIDADEDESC >= LAST_DAY(TO_DATE(V_DTPERIODO))
					   AND DTFINALVALIDADEDESC IS NOT NULL
					   AND DTFINALVALIDADEDESC = (SELECT MIN(DTFINALVALIDADEDESC)
													FROM FCT_DESCPERIODONEGOCONT DESCPER
													JOIN FCT_NEGOCIACAOCONTRATO NEG
													  ON NEG.NRNEGOCIACAOCONTRATO = DESCPER.NRNEGOCIACAOCONTRATO
													 AND NEG.NRORG = DESCPER.NRORG
													JOIN FCT_ITNEGOCIACAOCONTRATO ITNEG
													  ON ITNEG.NRNEGOCIACAOCONTRATO = NEG.NRNEGOCIACAOCONTRATO
													  AND ITNEG.NRORG = NEG.NRORG
													WHERE ITNEG.NRITEMOCONTRATO = C_CALC.NRITEMOCONTRATO
													  AND NEG.NRPARCFATURA = C_CALC.NRPARCFATURA
													  AND NEG.NRSEQCONTRATO = C_CALC.NRSEQCONTRATO
													  AND NEG.NRORG = P_NRORG
													  AND DTFINALVALIDADEDESC >= LAST_DAY(TO_DATE(V_DTPERIODO))
													  AND DTFINALVALIDADEDESC IS NOT NULL);
				EXCEPTION
					WHEN NO_DATA_FOUND THEN
						V_DESCPERIODO := 0;
				END;
				
				IF (V_DESCPERIODO > 0) THEN
					IF V_POSINI = 1 THEN
						V_VALORAUX := V_VALORAUX - ((V_VALORAUX*V_DESCPERIODO)/100);
					END IF;
					IF V_POSINI = 2 THEN
						V_VALORAUX2 := V_VALORAUX2 - ((V_VALORAUX2*V_DESCPERIODO)/100);
					END IF;
					IF V_POSINI = 3 THEN
						V_VALORAUX3 := V_VALORAUX3 - ((V_VALORAUX3*V_DESCPERIODO)/100);
					END IF;
				END IF;
			END IF;

			/* 4 - Se houver negociação no contrato, calcula a negociação do contrato */

			FOR C_NEGCONT IN (SELECT NEGCONT.IDTIPONEGOCIA, PARCNEGCT.VRPARCELANEGOCIA
								FROM FCT_NEGCONTRATO NEGCONT
								JOIN FCT_PARCELASNEGCONTR PARCNEGCT
								  ON PARCNEGCT.NRNEGCONTRATO = NEGCONT.NRNEGCONTRATO
								 AND PARCNEGCT.NRORG = NEGCONT.NRORG
							   WHERE NEGCONT.IDREALIZARNEGOCIACAO = 'M'
								 AND ((NEGCONT.NRSEQCONTRATO = C_CALC.NRSEQCONTRATO AND NEGCONT.NRAGRUPAMENTO IS NULL) 
								  OR (NEGCONT.NRSEQCONTRATO IS NULL AND NEGCONT.NRAGRUPAMENTO = (SELECT NRAGRUPAMENTO 
																								   FROM FCT_RELACAGRUPAMENTOCONT
																								  WHERE NRSEQCONTRATO = C_CALC.NRSEQCONTRATO))) 
								 AND ((NRITEMOCONTRATO IS NULL) OR (NRITEMOCONTRATO =  C_CALC.NRITEMOCONTRATO))
								 AND TO_DATE(V_DTPERIODO) BETWEEN DTINIPARCNEGOCIA AND DTFIMPARCNEGOCIA
								 AND NEGCONT.NRORG = P_NRORG

							   UNION ALL

							   SELECT NEGCONT.IDTIPONEGOCIA, PARCNEGCT.VRPARCELANEGOCIA
								 FROM FCT_NEGCONTRATO NEGCONT
								 JOIN FCT_PARCELASAPURNEGCONTRATO PARCNEGCT
								   ON PARCNEGCT.NRNEGCONTRATO = NEGCONT.NRNEGCONTRATO
								  AND PARCNEGCT.NRORG = NEGCONT.NRORG
								WHERE NEGCONT.IDREALIZARNEGOCIACAO = 'A'
								  AND ((NEGCONT.NRSEQCONTRATO = C_CALC.NRSEQCONTRATO AND NEGCONT.NRAGRUPAMENTO IS NULL) 
								   OR (NEGCONT.NRSEQCONTRATO IS NULL AND NEGCONT.NRAGRUPAMENTO = (SELECT NRAGRUPAMENTO 
																						 FROM FCT_RELACAGRUPAMENTOCONT
																						WHERE NRSEQCONTRATO = C_CALC.NRSEQCONTRATO)))
								  AND PARCNEGCT.NRFATURACONT = V_NRFATURACONT
								  AND NEGCONT.NRORG = P_NRORG) LOOP
				IF V_POSINI = 1 THEN
					IF C_NEGCONT.IDTIPONEGOCIA = 'VF' THEN -- Valor Fixo
						V_VALORAUX := C_NEGCONT.VRPARCELANEGOCIA;
					END IF;
					IF C_NEGCONT.IDTIPONEGOCIA = 'DP' THEN -- Desconto (Percentual)
						V_VALORAUX := V_VALORAUX - ((V_VALORAUX*C_NEGCONT.VRPARCELANEGOCIA)/100);
					END IF;
					IF C_NEGCONT.IDTIPONEGOCIA = 'DV' THEN  -- Desconto (Valor)
						IF V_VALORAUX <> 0 THEN
							V_VALORAUX := V_VALORAUX - C_NEGCONT.VRPARCELANEGOCIA;
						END IF;
					END IF;
					IF C_NEGCONT.IDTIPONEGOCIA = 'AP' THEN -- Acréscimo (Percentual)
						V_VALORAUX := V_VALORAUX + ((V_VALORAUX*C_NEGCONT.VRPARCELANEGOCIA)/100);
					END IF;
					IF C_NEGCONT.IDTIPONEGOCIA = 'AV' THEN-- Acréscimo (Valor)
						V_VALORAUX := V_VALORAUX + C_NEGCONT.VRPARCELANEGOCIA;
					END IF;
				END IF;
				
				IF V_POSINI = 2 THEN
					IF C_NEGCONT.IDTIPONEGOCIA = 'VF' THEN -- Valor Fixo
						V_VALORAUX2 := C_NEGCONT.VRPARCELANEGOCIA;
					END IF;
					IF C_NEGCONT.IDTIPONEGOCIA = 'DP' THEN -- Desconto (Percentual)
						V_VALORAUX2 := V_VALORAUX2 - ((V_VALORAUX2*C_NEGCONT.VRPARCELANEGOCIA)/100);
					END IF;
					IF C_NEGCONT.IDTIPONEGOCIA = 'DV' THEN  -- Desconto (Valor)
						IF V_VALORAUX2 <> 0 THEN
							V_VALORAUX2 := V_VALORAUX2 - C_NEGCONT.VRPARCELANEGOCIA;
						END IF;
					END IF;
					IF C_NEGCONT.IDTIPONEGOCIA = 'AP' THEN -- Acréscimo (Percentual)
						V_VALORAUX2 := V_VALORAUX2 + ((V_VALORAUX2*C_NEGCONT.VRPARCELANEGOCIA)/100);
					END IF;
					IF C_NEGCONT.IDTIPONEGOCIA = 'AV' THEN-- Acréscimo (Valor)
						V_VALORAUX2 := V_VALORAUX2 + C_NEGCONT.VRPARCELANEGOCIA;
					END IF;
				END IF;
				
				IF V_POSINI = 3 THEN
					IF C_NEGCONT.IDTIPONEGOCIA = 'VF' THEN -- Valor Fixo
						V_VALORAUX3 := C_NEGCONT.VRPARCELANEGOCIA;
					END IF;
					IF C_NEGCONT.IDTIPONEGOCIA = 'DP' THEN -- Desconto (Percentual)
						V_VALORAUX3 := V_VALORAUX3 - ((V_VALORAUX3*C_NEGCONT.VRPARCELANEGOCIA)/100);
					END IF;
					IF C_NEGCONT.IDTIPONEGOCIA = 'DV' THEN  -- Desconto (Valor)
						IF V_VALORAUX3 <> 0 THEN
							V_VALORAUX3 := V_VALORAUX3 - C_NEGCONT.VRPARCELANEGOCIA;
						END IF;
					END IF;
					IF C_NEGCONT.IDTIPONEGOCIA = 'AP' THEN -- Acréscimo (Percentual)
						V_VALORAUX3 := V_VALORAUX3 + ((V_VALORAUX3*C_NEGCONT.VRPARCELANEGOCIA)/100);
					END IF;
					IF C_NEGCONT.IDTIPONEGOCIA = 'AV' THEN-- Acréscimo (Valor)
						V_VALORAUX3 := V_VALORAUX3 + C_NEGCONT.VRPARCELANEGOCIA;
					END IF;
				END IF;

			END LOOP;
			
			V_POSINI := V_POSINI+1;
		
		END LOOP;
		
		/* 5 - Grava os registros */
		
		IF ((P_TIPO = 'SERVICO') OR (P_TIPO = 'EXPORTACAO')) THEN

			IF ((V_SERVICOANTE <> -1) AND (C_CALC.CDSERVORCA <> V_SERVICOANTE)) THEN 
				
				/* DIFERENCA */
				V_VRDIFF  := ROUND((V_VALORSERV - V_VRFATURA),2);
				V_VRDIFF2 := ROUND((V_VALORSERV2 - V_VRFATURA2),2);
				V_VRDIFF3 := ROUND((V_VALORSERV3 - V_VRFATURA3),2);
				
				/* DESVIO */
				IF ((V_VALORSERV IS NULL) OR (V_VALORSERV = 0)) THEN 
				    V_DESVIO   := ROUND((ROUND((V_VRFATURA - V_VALORSERV),2) / 1)*100, 2);
				ELSE 
					V_DESVIO   := ROUND((ROUND((V_VRFATURA - V_VALORSERV),2) / ROUND(V_VALORSERV,2))*100, 2);
				END IF;
				
				IF ((V_VALORSERV2 IS NULL) OR (V_VALORSERV2 = 0)) THEN 
				    V_DESVIO2   := ROUND((ROUND((V_VRFATURA2 - V_VALORSERV2),2) / 1)*100, 2);
				ELSE 
					V_DESVIO2   := ROUND((ROUND((V_VRFATURA2 - V_VALORSERV2),2) / ROUND(V_VALORSERV2,2))*100, 2);
				END IF;
				
				IF ((V_VALORSERV3 IS NULL) OR (V_VALORSERV3 = 0)) THEN 
				    V_DESVIO3   := ROUND((ROUND((V_VRFATURA3 - V_VALORSERV3),2) / 1)*100, 2);
				ELSE 
					V_DESVIO3   := ROUND((ROUND((V_VRFATURA3 - V_VALORSERV3),2) / ROUND(V_VALORSERV3,2))*100, 2);
				END IF;
				
				/* GRAVA DADOS */
				OUT_RECORD.CDSERVORCA    := V_SERVICOANTE;
				OUT_RECORD.NMSERVORCA    := V_NMSERVANTE;
				OUT_RECORD.NRPARCNEGOCIO := NULL;
				OUT_RECORD.NMPARCEIRO    := NULL;
				OUT_RECORD.NRSEQCONTRATO := NULL;
				OUT_RECORD.CONTRATO      := NULL;
				
				OUT_RECORD.COMPETENCIA1  := V_PERIODO;
				OUT_RECORD.ESTIMADO1     := ROUND(V_VALORSERV,2);
				OUT_RECORD.FATURADO1     := ROUND(V_VRFATURA,2);
				OUT_RECORD.DIFERENCA1    := ROUND(V_VRDIFF,2);
				OUT_RECORD.DESVIO1       := V_DESVIO;
				OUT_RECORD.COMPETENCIA2  := V_PERIODO2;
				OUT_RECORD.ESTIMADO2     := ROUND(V_VALORSERV2,2);
				OUT_RECORD.FATURADO2     := ROUND(V_VRFATURA2,2);
				OUT_RECORD.DIFERENCA2    := ROUND(V_VRDIFF2,2);
				OUT_RECORD.DESVIO2       := V_DESVIO2;
				OUT_RECORD.COMPETENCIA3  := V_PERIODO3;
				OUT_RECORD.ESTIMADO3     := ROUND(V_VALORSERV3,2);
				OUT_RECORD.FATURADO3     := ROUND(V_VRFATURA3,2);
				OUT_RECORD.DIFERENCA3    := ROUND(V_VRDIFF3,2);
				OUT_RECORD.DESVIO3       := V_DESVIO3;
				
				OUT_RECORD.NRORG         := P_NRORG;
				OUT_RECORD.DTINCLUSAO    := SYSDATE;

				PIPE ROW (OUT_RECORD);
                
                V_SERVICOANTE  := C_CALC.CDSERVORCA;
				V_NMSERVANTE   := C_CALC.NMSERVORCA;
				
				/* ESTIMADO */
				V_VALORSERV    := V_VALORAUX;
				V_VALORSERV2   := V_VALORAUX2;
				V_VALORSERV3   := V_VALORAUX3;
				
				/* FATURADO */
			    V_VRFATURA   := V_VALORFATAUX;
	            V_VRFATURA2  := V_VALORFATAUX2;
	            V_VRFATURA3  := V_VALORFATAUX3;
                
			ELSE 
				V_SERVICOANTE  := C_CALC.CDSERVORCA;
				V_NMSERVANTE   := C_CALC.NMSERVORCA;

				/* ESTIMADO */
				V_VALORSERV    := V_VALORSERV + V_VALORAUX; 
				V_VALORSERV2   := V_VALORSERV2 + V_VALORAUX3; 
				V_VALORSERV3   := V_VALORSERV3 + V_VALORAUX3;

                /* FATURADO */
			    V_VRFATURA   := V_VRFATURA + V_VALORFATAUX;
	            V_VRFATURA2  := V_VRFATURA2 + V_VALORFATAUX2;
	            V_VRFATURA3  := V_VRFATURA3 + V_VALORFATAUX3;				

			END IF;

		END IF;


		IF ((P_TIPO = 'PARCEIRO') OR (P_TIPO = 'EXPORTACAO')) THEN

			IF ((V_PARCEIROANTE <> -1) AND (C_CALC.NRPARCFATURA <> V_PARCEIROANTE)) THEN 
				
				/* DIFERENCA */
				V_VRDIFF  := ROUND((V_VALORPARC - V_VRFATURA),2);
				V_VRDIFF2 := ROUND((V_VALORPARC2 - V_VRFATURA2),2);
				V_VRDIFF3 := ROUND((V_VALORPARC3 - V_VRFATURA3),2);
				
				/* DESVIO */
				IF ((V_VALORPARC IS NULL) OR (V_VALORPARC = 0)) THEN 
				    V_DESVIO   := ROUND((ROUND((V_VRFATURA - V_VALORPARC),2) / 1)*100, 2);
				ELSE 
					V_DESVIO   := ROUND((ROUND((V_VRFATURA - V_VALORPARC),2) / ROUND(V_VALORPARC,2))*100, 2);
				END IF;
				
				IF ((V_VALORPARC2 IS NULL) OR (V_VALORPARC2 = 0)) THEN 
				    V_DESVIO2   := ROUND((ROUND((V_VRFATURA2 - V_VALORPARC2),2) / 1)*100, 2);
				ELSE 
					V_DESVIO2   := ROUND((ROUND((V_VRFATURA2 - V_VALORPARC2),2) / ROUND(V_VALORPARC2,2))*100, 2);
				END IF;
				
				IF ((V_VALORPARC3 IS NULL) OR (V_VALORPARC3 = 0)) THEN 
				    V_DESVIO3   := ROUND((ROUND((V_VRFATURA3 - V_VALORPARC3),2) / 1)*100, 2);
				ELSE 
					V_DESVIO3   := ROUND((ROUND((V_VRFATURA3 - V_VALORPARC3),2) / ROUND(V_VALORPARC3,2))*100, 2);
				END IF;
				
				/* GRAVA DADOS */
				OUT_RECORD.CDSERVORCA    := V_SERVICOANTEPARC;
				OUT_RECORD.NMSERVORCA    := V_NMSERVANTEPARC;
				OUT_RECORD.NRPARCNEGOCIO := V_PARCEIROANTE;
				OUT_RECORD.NMPARCEIRO    := V_NMPARCANTE;
				OUT_RECORD.NRSEQCONTRATO := NULL;
				OUT_RECORD.CONTRATO      := NULL;
				
				OUT_RECORD.COMPETENCIA1  := V_PERIODO;
				OUT_RECORD.ESTIMADO1     := ROUND(V_VALORPARC,2);
				OUT_RECORD.FATURADO1     := ROUND(V_VRFATURA,2);
				OUT_RECORD.DIFERENCA1    := ROUND(V_VRDIFF,2);
				OUT_RECORD.DESVIO1       := V_DESVIO;
				OUT_RECORD.COMPETENCIA2  := V_PERIODO2;
				OUT_RECORD.ESTIMADO2     := ROUND(V_VALORPARC2,2);
				OUT_RECORD.FATURADO2     := ROUND(V_VRFATURA2,2);
				OUT_RECORD.DIFERENCA2    := ROUND(V_VRDIFF2,2);
				OUT_RECORD.DESVIO2       := V_DESVIO2;
				OUT_RECORD.COMPETENCIA3  := V_PERIODO3;
				OUT_RECORD.ESTIMADO3     := ROUND(V_VALORPARC3,2);
				OUT_RECORD.FATURADO3     := ROUND(V_VRFATURA3,2);
				OUT_RECORD.DIFERENCA3    := ROUND(V_VRDIFF3,2);
				OUT_RECORD.DESVIO3       := V_DESVIO3;
				
				OUT_RECORD.NRORG         := P_NRORG;
				OUT_RECORD.DTINCLUSAO    := SYSDATE;

				PIPE ROW (OUT_RECORD);
				
                V_SERVICOANTEPARC := C_CALC.CDSERVORCA;
				V_NMSERVANTEPARC  := C_CALC.NMSERVORCA;
				V_PARCEIROANTE    := C_CALC.NRPARCFATURA;
				V_NMPARCANTE      := C_CALC.NMPARCEIRO;
				
				/* ESTIMADO */
				V_VALORPARC    := V_VALORAUX;
				V_VALORPARC2   := V_VALORAUX2;
				V_VALORPARC3   := V_VALORAUX3;
				
				/* FATURADO */
			    V_VRFATURA   := V_VALORFATAUX;
	            V_VRFATURA2  := V_VALORFATAUX2;
	            V_VRFATURA3  := V_VALORFATAUX3;
                
			ELSE 
				V_SERVICOANTEPARC  := C_CALC.CDSERVORCA;
				V_NMSERVANTEPARC   := C_CALC.NMSERVORCA;
				V_PARCEIROANTE     := C_CALC.NRPARCFATURA;
				V_NMPARCANTE       := C_CALC.NMPARCEIRO;
				
				/* ESTIMADO */
				V_VALORPARC    := V_VALORPARC + V_VALORAUX; 
				V_VALORPARC2   := V_VALORPARC2 + V_VALORAUX2; 
				V_VALORPARC3   := V_VALORPARC3 + V_VALORAUX3;

                /* FATURADO */
			    V_VRFATURA   := V_VRFATURA + V_VALORFATAUX;
	            V_VRFATURA2  := V_VRFATURA2 + V_VALORFATAUX2;
	            V_VRFATURA3  := V_VRFATURA3 + V_VALORFATAUX3;				

			END IF;

		END IF;

		IF ((P_TIPO = 'CONTRATO') OR (P_TIPO = 'EXPORTACAO')) THEN

			IF ((V_CONTRATOANTE <> -1) AND (C_CALC.NRSEQCONTRATO <> V_CONTRATOANTE)) THEN 
			
				/* DIFERENCA */
				V_VRDIFF  := ROUND((V_VALORCONTR - V_VRFATURA),2);
				V_VRDIFF2 := ROUND((V_VALORCONTR2 - V_VRFATURA2),2);
				V_VRDIFF3 := ROUND((V_VALORCONTR3 - V_VRFATURA3),2);
				
				/* DESVIO */
				
				IF ((V_VALORCONTR IS NULL) OR (V_VALORCONTR = 0)) THEN 
				    V_DESVIO   := ROUND((ROUND((V_VRFATURA - V_VALORCONTR),2) / 1)*100, 2);
				ELSE 
					V_DESVIO   := ROUND((ROUND((V_VRFATURA - V_VALORCONTR),2) / ROUND(V_VALORCONTR,2))*100, 2);
				END IF;
				
				IF ((V_VALORCONTR2 IS NULL) OR (V_VALORCONTR2 = 0)) THEN 
				    V_DESVIO2   := ROUND((ROUND((V_VRFATURA2 - V_VALORCONTR2),2) / 1)*100, 2);
				ELSE 
					V_DESVIO2   := ROUND((ROUND((V_VRFATURA2 - V_VALORCONTR2),2) / ROUND(V_VALORCONTR2,2))*100, 2);
				END IF;
				
				IF ((V_VALORCONTR3 IS NULL) OR (V_VALORCONTR3 = 0)) THEN 
				    V_DESVIO3   := ROUND((ROUND((V_VRFATURA3 - V_VALORCONTR3),2) / 1)*100, 2);
				ELSE 
					V_DESVIO3   := ROUND((ROUND((V_VRFATURA3 - V_VALORCONTR3),2) / ROUND(V_VALORCONTR3,2))*100, 2);
				END IF;
				
		
		        /* GRAVA DADOS */
				OUT_RECORD.CDSERVORCA    := V_SERVICOANTECONT;
				OUT_RECORD.NMSERVORCA    := V_NMSERVANTECONT;
				OUT_RECORD.NRPARCNEGOCIO := V_PARCEIROANTECONT;
				OUT_RECORD.NMPARCEIRO    := V_NMPARCANTECONT;
				OUT_RECORD.NRSEQCONTRATO := V_CONTRATOANTE;
				OUT_RECORD.CONTRATO      := V_CODCONTRANTE;
				
				OUT_RECORD.COMPETENCIA1  := V_PERIODO;
				OUT_RECORD.ESTIMADO1     := ROUND(V_VALORCONTR,2);
				OUT_RECORD.FATURADO1     := ROUND(V_VRFATURA,2);
				OUT_RECORD.DIFERENCA1    := ROUND(V_VRDIFF,2);
				OUT_RECORD.DESVIO1       := V_DESVIO;
				OUT_RECORD.COMPETENCIA2  := V_PERIODO2;
				OUT_RECORD.ESTIMADO2     := ROUND(V_VALORCONTR2,2);
				OUT_RECORD.FATURADO2     := ROUND(V_VRFATURA2,2);
				OUT_RECORD.DIFERENCA2    := ROUND(V_VRDIFF2,2);
				OUT_RECORD.DESVIO2       := V_DESVIO2;
				OUT_RECORD.COMPETENCIA3  := V_PERIODO3;
				OUT_RECORD.ESTIMADO3     := ROUND(V_VALORCONTR3,2);
				OUT_RECORD.FATURADO3     := ROUND(V_VRFATURA3,2);
				OUT_RECORD.DIFERENCA3    := ROUND(V_VRDIFF3,2);
				OUT_RECORD.DESVIO3       := V_DESVIO3;
				
				OUT_RECORD.NRORG         := P_NRORG;
				OUT_RECORD.DTINCLUSAO    := SYSDATE;

				PIPE ROW (OUT_RECORD);
                
				V_SERVICOANTECONT  := C_CALC.CDSERVORCA;
				V_NMSERVANTECONT   := C_CALC.NMSERVORCA;
				V_PARCEIROANTECONT := C_CALC.NRPARCFATURA;
				V_NMPARCANTECONT   := C_CALC.NMPARCEIRO;
				V_CONTRATOANTE     := C_CALC.NRSEQCONTRATO;
	            V_CODCONTRANTE     := C_CALC.NRCONTRATOFCT; 
				
				/* ESTIMADO */
				V_VALORCONTR   :=  V_VALORAUX; 
				V_VALORCONTR2  :=  V_VALORAUX2; 
				V_VALORCONTR3  :=  V_VALORAUX3; 
				
				/* FATURADO */
			    V_VRFATURA   := V_VALORFATAUX;
	            V_VRFATURA2  := V_VALORFATAUX2;
	            V_VRFATURA3  := V_VALORFATAUX3;

			ELSE
                V_SERVICOANTECONT  := C_CALC.CDSERVORCA;
				V_NMSERVANTECONT   := C_CALC.NMSERVORCA;
				V_PARCEIROANTECONT := C_CALC.NRPARCFATURA;
				V_NMPARCANTECONT   := C_CALC.NMPARCEIRO;
				V_CONTRATOANTE     := C_CALC.NRSEQCONTRATO;
	            V_CODCONTRANTE     := C_CALC.NRCONTRATOFCT; 
		
				/* ESTIMADO */
				V_VALORCONTR   := V_VALORCONTR + V_VALORAUX; 
				V_VALORCONTR2  := V_VALORCONTR2 + V_VALORAUX2;
				V_VALORCONTR3  := V_VALORCONTR3 + V_VALORAUX3;
				
				/* FATURADO */
			    V_VRFATURA   := V_VALORFATAUX;
	            V_VRFATURA2  := V_VALORFATAUX2;
	            V_VRFATURA3  := V_VALORFATAUX3;

			END IF;

		END IF;

	END LOOP;

	IF ((P_TIPO = 'SERVICO') OR (P_TIPO = 'EXPORTACAO')) THEN

		/*DIFERENCA*/
		V_VRDIFF  := ROUND((V_VALORSERV - V_VRFATURA),2);
		V_VRDIFF2 := ROUND((V_VALORSERV2 - V_VRFATURA2),2);
		V_VRDIFF3 := ROUND((V_VALORSERV3 - V_VRFATURA3),2);
		
		/*DESVIO*/
		IF ((V_VALORSERV IS NULL) OR (V_VALORSERV = 0)) THEN 
			V_DESVIO   := ROUND((ROUND((V_VRFATURA - V_VALORSERV),2) / 1)*100, 2);
		ELSE 
			V_DESVIO   := ROUND((ROUND((V_VRFATURA - V_VALORSERV),2) / ROUND(V_VALORSERV,2))*100, 2);
		END IF;
		
		IF ((V_VALORSERV2 IS NULL) OR (V_VALORSERV2 = 0)) THEN 
			V_DESVIO2   := ROUND((ROUND((V_VRFATURA2 - V_VALORSERV2),2) / 1)*100, 2);
		ELSE 
			V_DESVIO2   := ROUND((ROUND((V_VRFATURA2 - V_VALORSERV2),2) / ROUND(V_VALORSERV2,2))*100, 2);
		END IF;
		
		IF ((V_VALORSERV3 IS NULL) OR (V_VALORSERV3 = 0)) THEN 
			V_DESVIO3   := ROUND((ROUND((V_VRFATURA3 - V_VALORSERV3),2) / 1)*100, 2);
		ELSE 
			V_DESVIO3   := ROUND((ROUND((V_VRFATURA3 - V_VALORSERV3),2) / ROUND(V_VALORSERV3,2))*100, 2);
		END IF;
			
		/* GRAVA DADOS */	
		OUT_RECORD.CDSERVORCA    := V_SERVICOANTE;
		OUT_RECORD.NMSERVORCA    := V_NMSERVANTE;
		OUT_RECORD.NRPARCNEGOCIO := NULL;
		OUT_RECORD.NMPARCEIRO    := NULL;
		OUT_RECORD.NRSEQCONTRATO := NULL;
		OUT_RECORD.CONTRATO      := NULL;
		
		OUT_RECORD.COMPETENCIA1  := V_PERIODO;
		OUT_RECORD.ESTIMADO1     := ROUND(V_VALORSERV,2);
		OUT_RECORD.FATURADO1     := ROUND(V_VRFATURA,2);
		OUT_RECORD.DIFERENCA1    := ROUND(V_VRDIFF,2);
		OUT_RECORD.DESVIO1       := V_DESVIO;
		OUT_RECORD.COMPETENCIA2  := V_PERIODO2;
		OUT_RECORD.ESTIMADO2     := ROUND(V_VALORSERV2,2);
		OUT_RECORD.FATURADO2     := ROUND(V_VRFATURA2,2);
		OUT_RECORD.DIFERENCA2    := ROUND(V_VRDIFF2,2);
		OUT_RECORD.DESVIO2       := V_DESVIO2;
		OUT_RECORD.COMPETENCIA3  := V_PERIODO3;
		OUT_RECORD.ESTIMADO3     := ROUND(V_VALORSERV3,2);
		OUT_RECORD.FATURADO3     := ROUND(V_VRFATURA3,2);
		OUT_RECORD.DIFERENCA3    := ROUND(V_VRDIFF3,2);
		OUT_RECORD.DESVIO3       := V_DESVIO3;
		
		OUT_RECORD.NRORG         := P_NRORG;
		OUT_RECORD.DTINCLUSAO    := SYSDATE;

		PIPE ROW (OUT_RECORD);

	END IF;


	IF ((P_TIPO = 'PARCEIRO') OR (P_TIPO = 'EXPORTACAO')) THEN
		
		/* DIFERENCA */
		V_VRDIFF  := ROUND((V_VALORPARC - V_VRFATURA),2);
		V_VRDIFF2 := ROUND((V_VALORPARC2 - V_VRFATURA2),2);
		V_VRDIFF3 := ROUND((V_VALORPARC3 - V_VRFATURA3),2);
		
		/* DESVIO */
		IF ((V_VALORPARC IS NULL) OR (V_VALORPARC = 0)) THEN 
			V_DESVIO   := ROUND((ROUND((V_VRFATURA - V_VALORPARC),2) / 1)*100, 2);
		ELSE 
			V_DESVIO   := ROUND((ROUND((V_VRFATURA - V_VALORPARC),2) / ROUND(V_VALORPARC,2))*100, 2);
		END IF;
		
		IF ((V_VALORPARC2 IS NULL) OR (V_VALORPARC2 = 0)) THEN 
			V_DESVIO2   := ROUND((ROUND((V_VRFATURA2 - V_VALORPARC2),2) / 1)*100, 2);
		ELSE 
			V_DESVIO2   := ROUND((ROUND((V_VRFATURA2 - V_VALORPARC2),2) / ROUND(V_VALORPARC2,2))*100, 2);
		END IF;
		
		IF ((V_VALORPARC3 IS NULL) OR (V_VALORPARC3 = 0)) THEN 
			V_DESVIO3   := ROUND((ROUND((V_VRFATURA3 - V_VALORPARC3),2) / 1)*100, 2);
		ELSE 
			V_DESVIO3   := ROUND((ROUND((V_VRFATURA3 - V_VALORPARC3),2) / ROUND(V_VALORPARC3,2))*100, 2);
		END IF;
		
        /* GRAVA DADOS */		
		OUT_RECORD.CDSERVORCA    := V_SERVICOANTEPARC;
		OUT_RECORD.NMSERVORCA    := V_NMSERVANTEPARC;
		OUT_RECORD.NRPARCNEGOCIO := V_PARCEIROANTE;
		OUT_RECORD.NMPARCEIRO    := V_NMPARCANTE;
		OUT_RECORD.NRSEQCONTRATO := NULL;
		OUT_RECORD.CONTRATO      := NULL;
		
		OUT_RECORD.COMPETENCIA1  := V_PERIODO;
		OUT_RECORD.ESTIMADO1     := ROUND(V_VALORPARC,2);
		OUT_RECORD.FATURADO1     := ROUND(V_VRFATURA,2);
		OUT_RECORD.DIFERENCA1    := ROUND(V_VRDIFF,2);
		OUT_RECORD.DESVIO1       := V_DESVIO;
		OUT_RECORD.COMPETENCIA2  := V_PERIODO2;
		OUT_RECORD.ESTIMADO2     := ROUND(V_VALORPARC2,2);
		OUT_RECORD.FATURADO2     := ROUND(V_VRFATURA2,2);
		OUT_RECORD.DIFERENCA2    := ROUND(V_VRDIFF2,2);
		OUT_RECORD.DESVIO2       := V_DESVIO2;
		OUT_RECORD.COMPETENCIA3  := V_PERIODO3;
		OUT_RECORD.ESTIMADO3     := ROUND(V_VALORPARC3,2);
		OUT_RECORD.FATURADO3     := ROUND(V_VRFATURA3,2);
		OUT_RECORD.DIFERENCA3    := ROUND(V_VRDIFF3,2);
		OUT_RECORD.DESVIO3       := V_DESVIO3;
		
		OUT_RECORD.NRORG         := P_NRORG;
		OUT_RECORD.DTINCLUSAO    := SYSDATE;

		PIPE ROW (OUT_RECORD);

	END IF;

	IF ((P_TIPO = 'CONTRATO') OR (P_TIPO = 'EXPORTACAO')) THEN
		
		/* DIFERENCA */
		V_VRDIFF  := ROUND((V_VALORCONTR - V_VRFATURA),2);
		V_VRDIFF2 := ROUND((V_VALORCONTR2 - V_VRFATURA2),2);
		V_VRDIFF3 := ROUND((V_VALORCONTR3 - V_VRFATURA3),2);
		
		/* DESVIO */
		IF ((V_VALORCONTR IS NULL) OR (V_VALORCONTR = 0)) THEN 
			V_DESVIO   := ROUND((ROUND((V_VRFATURA - V_VALORCONTR),2) / 1)*100, 2);
		ELSE 
			V_DESVIO   := ROUND((ROUND((V_VRFATURA - V_VALORCONTR),2) / ROUND(V_VALORCONTR,2))*100, 2);
		END IF;
		
		IF ((V_VALORCONTR2 IS NULL) OR (V_VALORCONTR2 = 0)) THEN 
			V_DESVIO2   := ROUND((ROUND((V_VRFATURA2 - V_VALORCONTR2),2) / 1)*100, 2);
		ELSE 
			V_DESVIO2   := ROUND((ROUND((V_VRFATURA2 - V_VALORCONTR2),2) / ROUND(V_VALORCONTR2,2))*100, 2);
		END IF;
		
		IF ((V_VALORCONTR3 IS NULL) OR (V_VALORCONTR3 = 0)) THEN 
			V_DESVIO3   := ROUND((ROUND((V_VRFATURA3 - V_VALORCONTR3),2) / 1)*100, 2);
		ELSE 
			V_DESVIO3   := ROUND((ROUND((V_VRFATURA3 - V_VALORCONTR3),2) / ROUND(V_VALORCONTR3,2))*100, 2);
		END IF;
			
        /* GRAVA DADOS */	 			
		OUT_RECORD.CDSERVORCA    := V_SERVICOANTECONT;
		OUT_RECORD.NMSERVORCA    := V_NMSERVANTECONT;
		OUT_RECORD.NRPARCNEGOCIO := V_PARCEIROANTECONT;
		OUT_RECORD.NMPARCEIRO    := V_NMPARCANTECONT;
		OUT_RECORD.NRSEQCONTRATO := V_CONTRATOANTE;
		OUT_RECORD.CONTRATO      := V_CODCONTRANTE;
		
		OUT_RECORD.COMPETENCIA1  := V_PERIODO;
		OUT_RECORD.ESTIMADO1     := ROUND(V_VALORCONTR,2);
		OUT_RECORD.FATURADO1     := ROUND(V_VRFATURA,2);
		OUT_RECORD.DIFERENCA1    := ROUND(V_VRDIFF,2);
		OUT_RECORD.DESVIO1       := V_DESVIO;
		OUT_RECORD.COMPETENCIA2  := V_PERIODO2;
		OUT_RECORD.ESTIMADO2     := ROUND(V_VALORCONTR2,2);
		OUT_RECORD.FATURADO2     := ROUND(V_VRFATURA2,2);
		OUT_RECORD.DIFERENCA2    := ROUND(V_VRDIFF2,2);
		OUT_RECORD.DESVIO2       := V_DESVIO2;
		OUT_RECORD.COMPETENCIA3  := V_PERIODO3;
		OUT_RECORD.ESTIMADO3     := ROUND(V_VALORCONTR3,2);
		OUT_RECORD.FATURADO3     := ROUND(V_VRFATURA3,2);
		OUT_RECORD.DIFERENCA3    := ROUND(V_VRDIFF3,2);
		OUT_RECORD.DESVIO3       := V_DESVIO3;
		
		OUT_RECORD.NRORG         := P_NRORG;
		OUT_RECORD.DTINCLUSAO    := SYSDATE;

		PIPE ROW (OUT_RECORD);

	END IF;

	RETURN;

END;

/