<?php
/**
 * Created by PhpStorm.
 * User: phillipesilva
 * Date: 09/03/2016
 * Time: 18:25
 */

namespace Zeedhi\DevOps\Util;

use Doctrine\ORM\Mapping\ClassMetadata;
use Doctrine\ORM\Query\Filter\SQLFilter;
use Zeedhi\DevOps\Model\Util;

class LogicalDeleted extends SQLFilter{
    /**
     * Gets the SQL query part to add to a query.
     *
     * @param ClassMetaData $targetEntity
     * @param string        $targetTableAlias
     *
     * @return string The constraint SQL if there is available, empty string otherwise.
     */
    public function addFilterConstraint(ClassMetadata $targetEntity, $targetTableAlias) {
        $interfaceClass = "\\Zeedhi\\DevOps\\Model\\Util\\LogicalDeleted";
        $interfaceClassIsActiveColumn = "\\Zeedhi\\DevOps\\Model\\Util\\LogicalDeletedIsActiveColumn";
        $interfaceClassRelationship = "\\Zeedhi\\DevOps\\Model\\Util\\LogicalDeletedInRelationship";
        $filter = '';
        $entityReflection = $targetEntity->getReflectionClass();
        if ($entityReflection->implementsInterface($interfaceClassIsActiveColumn)) {
            $filter = " IS_ACTIVE <> 'D' ";
        } else if ($entityReflection->implementsInterface($interfaceClass)) {
            $filter = " STATUS <> 'D' ";
        } else if ($entityReflection->implementsInterface($interfaceClassRelationship)) {
            $filter = call_user_func($entityReflection->getName(). '::' .
                Util\LogicalDeletedInRelationship::NAME_FUNC_LOGICAL_DELETED ,$targetTableAlias);
        }
        return $filter;
    }
}