import { Http, Metadata } from '@zeedhi/core';
import { InstanceService } from '@/services/InstanceService';
import { AlertService, Form } from '@zeedhi/common';

export class OrganizationController {
    public async loadForm() {
		const callData = await Http.get('findOrganizacaoInfo');
		const form = InstanceService.getInstanceZdForm('organizacao-form');
		form.value.FOUNDATION = callData.data[0].FOUNDATION;
		form.value.BASE_CALENDAR	 = callData.data[0].CALENDAR_DEFAULT;
		form.value.CALENDAR	 = callData.data[0].CALENDAR;
		form.value.STRUCTURE	 = callData.data[0].STRUCTURE;
		form.value.NAME = callData.data[0].NAME;
		form.value.DESCRIPTION = callData.data[0].DESCRIPTION;
		form.value.TIME_SHEET_REQUIRED = callData.data[0].TIME_SHEET_REQUIRED;
		form.value.DOCUMENT = callData.data[0].DOCUMENT;
		form.value.MANAGERS = callData.data[0].MANAGERS;
      }

		public async submitEvent() {
		const form = Metadata.getInstance<Form>('organizacao-form');
		await Http.post('/saveOrganizacaoInfo', {
			DATA: form.value,
		});
		AlertService.show({
			name: 'submit-alert',
			text: 'form submit',
		});
	}
}
